/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package it.tref.liferay.mapit.map.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import it.tref.liferay.mapit.map.model.PluginPortletPreferences;
import it.tref.liferay.mapit.map.model.PluginPortletPreferencesModel;

import java.io.Serializable;

import java.sql.Types;

import java.util.HashMap;
import java.util.Map;

/**
 * The base model implementation for the PluginPortletPreferences service. Represents a row in the &quot;MI_Map_PluginPortletPrefs&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link it.tref.liferay.mapit.map.model.PluginPortletPreferencesModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link PluginPortletPreferencesImpl}.
 * </p>
 *
 * @author
 * @see PluginPortletPreferencesImpl
 * @see it.tref.liferay.mapit.map.model.PluginPortletPreferences
 * @see it.tref.liferay.mapit.map.model.PluginPortletPreferencesModel
 * @generated
 */
public class PluginPortletPreferencesModelImpl extends BaseModelImpl<PluginPortletPreferences>
	implements PluginPortletPreferencesModel {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. All methods that expect a plugin portlet preferences model instance should use the {@link it.tref.liferay.mapit.map.model.PluginPortletPreferences} interface instead.
	 */
	public static final String TABLE_NAME = "MI_Map_PluginPortletPrefs";
	public static final Object[][] TABLE_COLUMNS = {
			{ "pluginPortletPreferencesId", Types.BIGINT },
			{ "ownerId", Types.BIGINT },
			{ "ownerType", Types.INTEGER },
			{ "plid", Types.BIGINT },
			{ "portletId", Types.VARCHAR },
			{ "plugin", Types.VARCHAR },
			{ "preferences", Types.CLOB }
		};
	public static final String TABLE_SQL_CREATE = "create table MI_Map_PluginPortletPrefs (pluginPortletPreferencesId LONG not null primary key,ownerId LONG,ownerType INTEGER,plid LONG,portletId VARCHAR(200) null,plugin VARCHAR(75) null,preferences TEXT null)";
	public static final String TABLE_SQL_DROP = "drop table MI_Map_PluginPortletPrefs";
	public static final String ORDER_BY_JPQL = " ORDER BY pluginPortletPreferences.pluginPortletPreferencesId ASC";
	public static final String ORDER_BY_SQL = " ORDER BY MI_Map_PluginPortletPrefs.pluginPortletPreferencesId ASC";
	public static final String DATA_SOURCE = "liferayDataSource";
	public static final String SESSION_FACTORY = "liferaySessionFactory";
	public static final String TX_MANAGER = "liferayTransactionManager";
	public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.entity.cache.enabled.it.tref.liferay.mapit.map.model.PluginPortletPreferences"),
			true);
	public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.finder.cache.enabled.it.tref.liferay.mapit.map.model.PluginPortletPreferences"),
			true);
	public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.column.bitmask.enabled.it.tref.liferay.mapit.map.model.PluginPortletPreferences"),
			true);
	public static long OWNERID_COLUMN_BITMASK = 1L;
	public static long OWNERTYPE_COLUMN_BITMASK = 2L;
	public static long PLID_COLUMN_BITMASK = 4L;
	public static long PLUGIN_COLUMN_BITMASK = 8L;
	public static long PORTLETID_COLUMN_BITMASK = 16L;
	public static long PLUGINPORTLETPREFERENCESID_COLUMN_BITMASK = 32L;
	public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
				"lock.expiration.time.it.tref.liferay.mapit.map.model.PluginPortletPreferences"));

	public PluginPortletPreferencesModelImpl() {
	}

	@Override
	public long getPrimaryKey() {
		return _pluginPortletPreferencesId;
	}

	@Override
	public void setPrimaryKey(long primaryKey) {
		setPluginPortletPreferencesId(primaryKey);
	}

	@Override
	public Serializable getPrimaryKeyObj() {
		return _pluginPortletPreferencesId;
	}

	@Override
	public void setPrimaryKeyObj(Serializable primaryKeyObj) {
		setPrimaryKey(((Long)primaryKeyObj).longValue());
	}

	@Override
	public Class<?> getModelClass() {
		return PluginPortletPreferences.class;
	}

	@Override
	public String getModelClassName() {
		return PluginPortletPreferences.class.getName();
	}

	@Override
	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("pluginPortletPreferencesId",
			getPluginPortletPreferencesId());
		attributes.put("ownerId", getOwnerId());
		attributes.put("ownerType", getOwnerType());
		attributes.put("plid", getPlid());
		attributes.put("portletId", getPortletId());
		attributes.put("plugin", getPlugin());
		attributes.put("preferences", getPreferences());

		return attributes;
	}

	@Override
	public void setModelAttributes(Map<String, Object> attributes) {
		Long pluginPortletPreferencesId = (Long)attributes.get(
				"pluginPortletPreferencesId");

		if (pluginPortletPreferencesId != null) {
			setPluginPortletPreferencesId(pluginPortletPreferencesId);
		}

		Long ownerId = (Long)attributes.get("ownerId");

		if (ownerId != null) {
			setOwnerId(ownerId);
		}

		Integer ownerType = (Integer)attributes.get("ownerType");

		if (ownerType != null) {
			setOwnerType(ownerType);
		}

		Long plid = (Long)attributes.get("plid");

		if (plid != null) {
			setPlid(plid);
		}

		String portletId = (String)attributes.get("portletId");

		if (portletId != null) {
			setPortletId(portletId);
		}

		String plugin = (String)attributes.get("plugin");

		if (plugin != null) {
			setPlugin(plugin);
		}

		String preferences = (String)attributes.get("preferences");

		if (preferences != null) {
			setPreferences(preferences);
		}
	}

	@Override
	public long getPluginPortletPreferencesId() {
		return _pluginPortletPreferencesId;
	}

	@Override
	public void setPluginPortletPreferencesId(long pluginPortletPreferencesId) {
		_pluginPortletPreferencesId = pluginPortletPreferencesId;
	}

	@Override
	public long getOwnerId() {
		return _ownerId;
	}

	@Override
	public void setOwnerId(long ownerId) {
		_columnBitmask |= OWNERID_COLUMN_BITMASK;

		if (!_setOriginalOwnerId) {
			_setOriginalOwnerId = true;

			_originalOwnerId = _ownerId;
		}

		_ownerId = ownerId;
	}

	public long getOriginalOwnerId() {
		return _originalOwnerId;
	}

	@Override
	public int getOwnerType() {
		return _ownerType;
	}

	@Override
	public void setOwnerType(int ownerType) {
		_columnBitmask |= OWNERTYPE_COLUMN_BITMASK;

		if (!_setOriginalOwnerType) {
			_setOriginalOwnerType = true;

			_originalOwnerType = _ownerType;
		}

		_ownerType = ownerType;
	}

	public int getOriginalOwnerType() {
		return _originalOwnerType;
	}

	@Override
	public long getPlid() {
		return _plid;
	}

	@Override
	public void setPlid(long plid) {
		_columnBitmask |= PLID_COLUMN_BITMASK;

		if (!_setOriginalPlid) {
			_setOriginalPlid = true;

			_originalPlid = _plid;
		}

		_plid = plid;
	}

	public long getOriginalPlid() {
		return _originalPlid;
	}

	@Override
	public String getPortletId() {
		if (_portletId == null) {
			return StringPool.BLANK;
		}
		else {
			return _portletId;
		}
	}

	@Override
	public void setPortletId(String portletId) {
		_columnBitmask |= PORTLETID_COLUMN_BITMASK;

		if (_originalPortletId == null) {
			_originalPortletId = _portletId;
		}

		_portletId = portletId;
	}

	public String getOriginalPortletId() {
		return GetterUtil.getString(_originalPortletId);
	}

	@Override
	public String getPlugin() {
		if (_plugin == null) {
			return StringPool.BLANK;
		}
		else {
			return _plugin;
		}
	}

	@Override
	public void setPlugin(String plugin) {
		_columnBitmask |= PLUGIN_COLUMN_BITMASK;

		if (_originalPlugin == null) {
			_originalPlugin = _plugin;
		}

		_plugin = plugin;
	}

	public String getOriginalPlugin() {
		return GetterUtil.getString(_originalPlugin);
	}

	@Override
	public String getPreferences() {
		if (_preferences == null) {
			return StringPool.BLANK;
		}
		else {
			return _preferences;
		}
	}

	@Override
	public void setPreferences(String preferences) {
		_preferences = preferences;
	}

	public long getColumnBitmask() {
		return _columnBitmask;
	}

	@Override
	public ExpandoBridge getExpandoBridge() {
		return ExpandoBridgeFactoryUtil.getExpandoBridge(0,
			PluginPortletPreferences.class.getName(), getPrimaryKey());
	}

	@Override
	public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
		ExpandoBridge expandoBridge = getExpandoBridge();

		expandoBridge.setAttributes(serviceContext);
	}

	@Override
	public PluginPortletPreferences toEscapedModel() {
		if (_escapedModel == null) {
			_escapedModel = (PluginPortletPreferences)ProxyUtil.newProxyInstance(_classLoader,
					_escapedModelInterfaces, new AutoEscapeBeanHandler(this));
		}

		return _escapedModel;
	}

	@Override
	public Object clone() {
		PluginPortletPreferencesImpl pluginPortletPreferencesImpl = new PluginPortletPreferencesImpl();

		pluginPortletPreferencesImpl.setPluginPortletPreferencesId(getPluginPortletPreferencesId());
		pluginPortletPreferencesImpl.setOwnerId(getOwnerId());
		pluginPortletPreferencesImpl.setOwnerType(getOwnerType());
		pluginPortletPreferencesImpl.setPlid(getPlid());
		pluginPortletPreferencesImpl.setPortletId(getPortletId());
		pluginPortletPreferencesImpl.setPlugin(getPlugin());
		pluginPortletPreferencesImpl.setPreferences(getPreferences());

		pluginPortletPreferencesImpl.resetOriginalValues();

		return pluginPortletPreferencesImpl;
	}

	@Override
	public int compareTo(PluginPortletPreferences pluginPortletPreferences) {
		long primaryKey = pluginPortletPreferences.getPrimaryKey();

		if (getPrimaryKey() < primaryKey) {
			return -1;
		}
		else if (getPrimaryKey() > primaryKey) {
			return 1;
		}
		else {
			return 0;
		}
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}

		if (!(obj instanceof PluginPortletPreferences)) {
			return false;
		}

		PluginPortletPreferences pluginPortletPreferences = (PluginPortletPreferences)obj;

		long primaryKey = pluginPortletPreferences.getPrimaryKey();

		if (getPrimaryKey() == primaryKey) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public int hashCode() {
		return (int)getPrimaryKey();
	}

	@Override
	public void resetOriginalValues() {
		PluginPortletPreferencesModelImpl pluginPortletPreferencesModelImpl = this;

		pluginPortletPreferencesModelImpl._originalOwnerId = pluginPortletPreferencesModelImpl._ownerId;

		pluginPortletPreferencesModelImpl._setOriginalOwnerId = false;

		pluginPortletPreferencesModelImpl._originalOwnerType = pluginPortletPreferencesModelImpl._ownerType;

		pluginPortletPreferencesModelImpl._setOriginalOwnerType = false;

		pluginPortletPreferencesModelImpl._originalPlid = pluginPortletPreferencesModelImpl._plid;

		pluginPortletPreferencesModelImpl._setOriginalPlid = false;

		pluginPortletPreferencesModelImpl._originalPortletId = pluginPortletPreferencesModelImpl._portletId;

		pluginPortletPreferencesModelImpl._originalPlugin = pluginPortletPreferencesModelImpl._plugin;

		pluginPortletPreferencesModelImpl._columnBitmask = 0;
	}

	@Override
	public CacheModel<PluginPortletPreferences> toCacheModel() {
		PluginPortletPreferencesCacheModel pluginPortletPreferencesCacheModel = new PluginPortletPreferencesCacheModel();

		pluginPortletPreferencesCacheModel.pluginPortletPreferencesId = getPluginPortletPreferencesId();

		pluginPortletPreferencesCacheModel.ownerId = getOwnerId();

		pluginPortletPreferencesCacheModel.ownerType = getOwnerType();

		pluginPortletPreferencesCacheModel.plid = getPlid();

		pluginPortletPreferencesCacheModel.portletId = getPortletId();

		String portletId = pluginPortletPreferencesCacheModel.portletId;

		if ((portletId != null) && (portletId.length() == 0)) {
			pluginPortletPreferencesCacheModel.portletId = null;
		}

		pluginPortletPreferencesCacheModel.plugin = getPlugin();

		String plugin = pluginPortletPreferencesCacheModel.plugin;

		if ((plugin != null) && (plugin.length() == 0)) {
			pluginPortletPreferencesCacheModel.plugin = null;
		}

		pluginPortletPreferencesCacheModel.preferences = getPreferences();

		String preferences = pluginPortletPreferencesCacheModel.preferences;

		if ((preferences != null) && (preferences.length() == 0)) {
			pluginPortletPreferencesCacheModel.preferences = null;
		}

		return pluginPortletPreferencesCacheModel;
	}

	@Override
	public String toString() {
		StringBundler sb = new StringBundler(15);

		sb.append("{pluginPortletPreferencesId=");
		sb.append(getPluginPortletPreferencesId());
		sb.append(", ownerId=");
		sb.append(getOwnerId());
		sb.append(", ownerType=");
		sb.append(getOwnerType());
		sb.append(", plid=");
		sb.append(getPlid());
		sb.append(", portletId=");
		sb.append(getPortletId());
		sb.append(", plugin=");
		sb.append(getPlugin());
		sb.append(", preferences=");
		sb.append(getPreferences());
		sb.append("}");

		return sb.toString();
	}

	@Override
	public String toXmlString() {
		StringBundler sb = new StringBundler(25);

		sb.append("<model><model-name>");
		sb.append("it.tref.liferay.mapit.map.model.PluginPortletPreferences");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>pluginPortletPreferencesId</column-name><column-value><![CDATA[");
		sb.append(getPluginPortletPreferencesId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>ownerId</column-name><column-value><![CDATA[");
		sb.append(getOwnerId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>ownerType</column-name><column-value><![CDATA[");
		sb.append(getOwnerType());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>plid</column-name><column-value><![CDATA[");
		sb.append(getPlid());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>portletId</column-name><column-value><![CDATA[");
		sb.append(getPortletId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>plugin</column-name><column-value><![CDATA[");
		sb.append(getPlugin());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>preferences</column-name><column-value><![CDATA[");
		sb.append(getPreferences());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private static ClassLoader _classLoader = PluginPortletPreferences.class.getClassLoader();
	private static Class<?>[] _escapedModelInterfaces = new Class[] {
			PluginPortletPreferences.class
		};
	private long _pluginPortletPreferencesId;
	private long _ownerId;
	private long _originalOwnerId;
	private boolean _setOriginalOwnerId;
	private int _ownerType;
	private int _originalOwnerType;
	private boolean _setOriginalOwnerType;
	private long _plid;
	private long _originalPlid;
	private boolean _setOriginalPlid;
	private String _portletId;
	private String _originalPortletId;
	private String _plugin;
	private String _originalPlugin;
	private String _preferences;
	private long _columnBitmask;
	private PluginPortletPreferences _escapedModel;
}