/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package it.tref.liferay.mapit.map.service.persistence;

import com.liferay.portal.kernel.cache.CacheRegistryUtil;
import com.liferay.portal.kernel.dao.orm.EntityCacheUtil;
import com.liferay.portal.kernel.dao.orm.FinderCacheUtil;
import com.liferay.portal.kernel.dao.orm.FinderPath;
import com.liferay.portal.kernel.dao.orm.Query;
import com.liferay.portal.kernel.dao.orm.QueryPos;
import com.liferay.portal.kernel.dao.orm.QueryUtil;
import com.liferay.portal.kernel.dao.orm.Session;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.log.Log;
import com.liferay.portal.kernel.log.LogFactoryUtil;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.InstanceFactory;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.kernel.util.PropsKeys;
import com.liferay.portal.kernel.util.PropsUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.kernel.util.StringUtil;
import com.liferay.portal.kernel.util.UnmodifiableList;
import com.liferay.portal.kernel.util.Validator;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.ModelListener;
import com.liferay.portal.service.persistence.impl.BasePersistenceImpl;

import it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException;
import it.tref.liferay.mapit.map.model.PluginPortletPreferences;
import it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesImpl;
import it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesModelImpl;

import java.io.Serializable;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * The persistence implementation for the plugin portlet preferences service.
 *
 * <p>
 * Caching information and settings can be found in <code>portal.properties</code>
 * </p>
 *
 * @author
 * @see PluginPortletPreferencesPersistence
 * @see PluginPortletPreferencesUtil
 * @generated
 */
public class PluginPortletPreferencesPersistenceImpl extends BasePersistenceImpl<PluginPortletPreferences>
	implements PluginPortletPreferencesPersistence {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. Always use {@link PluginPortletPreferencesUtil} to access the plugin portlet preferences persistence. Modify <code>service.xml</code> and rerun ServiceBuilder to regenerate this class.
	 */
	public static final String FINDER_CLASS_NAME_ENTITY = PluginPortletPreferencesImpl.class.getName();
	public static final String FINDER_CLASS_NAME_LIST_WITH_PAGINATION = FINDER_CLASS_NAME_ENTITY +
		".List1";
	public static final String FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION = FINDER_CLASS_NAME_ENTITY +
		".List2";
	public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_ALL = new FinderPath(PluginPortletPreferencesModelImpl.ENTITY_CACHE_ENABLED,
			PluginPortletPreferencesModelImpl.FINDER_CACHE_ENABLED,
			PluginPortletPreferencesImpl.class,
			FINDER_CLASS_NAME_LIST_WITH_PAGINATION, "findAll", new String[0]);
	public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_ALL = new FinderPath(PluginPortletPreferencesModelImpl.ENTITY_CACHE_ENABLED,
			PluginPortletPreferencesModelImpl.FINDER_CACHE_ENABLED,
			PluginPortletPreferencesImpl.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "findAll", new String[0]);
	public static final FinderPath FINDER_PATH_COUNT_ALL = new FinderPath(PluginPortletPreferencesModelImpl.ENTITY_CACHE_ENABLED,
			PluginPortletPreferencesModelImpl.FINDER_CACHE_ENABLED, Long.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countAll", new String[0]);
	public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_BY_PLUGIN = new FinderPath(PluginPortletPreferencesModelImpl.ENTITY_CACHE_ENABLED,
			PluginPortletPreferencesModelImpl.FINDER_CACHE_ENABLED,
			PluginPortletPreferencesImpl.class,
			FINDER_CLASS_NAME_LIST_WITH_PAGINATION, "findByPlugin",
			new String[] {
				String.class.getName(),
				
			Integer.class.getName(), Integer.class.getName(),
				OrderByComparator.class.getName()
			});
	public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_PLUGIN =
		new FinderPath(PluginPortletPreferencesModelImpl.ENTITY_CACHE_ENABLED,
			PluginPortletPreferencesModelImpl.FINDER_CACHE_ENABLED,
			PluginPortletPreferencesImpl.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "findByPlugin",
			new String[] { String.class.getName() },
			PluginPortletPreferencesModelImpl.PLUGIN_COLUMN_BITMASK);
	public static final FinderPath FINDER_PATH_COUNT_BY_PLUGIN = new FinderPath(PluginPortletPreferencesModelImpl.ENTITY_CACHE_ENABLED,
			PluginPortletPreferencesModelImpl.FINDER_CACHE_ENABLED, Long.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countByPlugin",
			new String[] { String.class.getName() });

	/**
	 * Returns all the plugin portlet preferenceses where plugin = &#63;.
	 *
	 * @param plugin the plugin
	 * @return the matching plugin portlet preferenceses
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public List<PluginPortletPreferences> findByPlugin(String plugin)
		throws SystemException {
		return findByPlugin(plugin, QueryUtil.ALL_POS, QueryUtil.ALL_POS, null);
	}

	/**
	 * Returns a range of all the plugin portlet preferenceses where plugin = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	 * </p>
	 *
	 * @param plugin the plugin
	 * @param start the lower bound of the range of plugin portlet preferenceses
	 * @param end the upper bound of the range of plugin portlet preferenceses (not inclusive)
	 * @return the range of matching plugin portlet preferenceses
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public List<PluginPortletPreferences> findByPlugin(String plugin,
		int start, int end) throws SystemException {
		return findByPlugin(plugin, start, end, null);
	}

	/**
	 * Returns an ordered range of all the plugin portlet preferenceses where plugin = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	 * </p>
	 *
	 * @param plugin the plugin
	 * @param start the lower bound of the range of plugin portlet preferenceses
	 * @param end the upper bound of the range of plugin portlet preferenceses (not inclusive)
	 * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	 * @return the ordered range of matching plugin portlet preferenceses
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public List<PluginPortletPreferences> findByPlugin(String plugin,
		int start, int end, OrderByComparator orderByComparator)
		throws SystemException {
		boolean pagination = true;
		FinderPath finderPath = null;
		Object[] finderArgs = null;

		if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
				(orderByComparator == null)) {
			pagination = false;
			finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_PLUGIN;
			finderArgs = new Object[] { plugin };
		}
		else {
			finderPath = FINDER_PATH_WITH_PAGINATION_FIND_BY_PLUGIN;
			finderArgs = new Object[] { plugin, start, end, orderByComparator };
		}

		List<PluginPortletPreferences> list = (List<PluginPortletPreferences>)FinderCacheUtil.getResult(finderPath,
				finderArgs, this);

		if ((list != null) && !list.isEmpty()) {
			for (PluginPortletPreferences pluginPortletPreferences : list) {
				if (!Validator.equals(plugin,
							pluginPortletPreferences.getPlugin())) {
					list = null;

					break;
				}
			}
		}

		if (list == null) {
			StringBundler query = null;

			if (orderByComparator != null) {
				query = new StringBundler(3 +
						(orderByComparator.getOrderByFields().length * 3));
			}
			else {
				query = new StringBundler(3);
			}

			query.append(_SQL_SELECT_PLUGINPORTLETPREFERENCES_WHERE);

			boolean bindPlugin = false;

			if (plugin == null) {
				query.append(_FINDER_COLUMN_PLUGIN_PLUGIN_1);
			}
			else if (plugin.equals(StringPool.BLANK)) {
				query.append(_FINDER_COLUMN_PLUGIN_PLUGIN_3);
			}
			else {
				bindPlugin = true;

				query.append(_FINDER_COLUMN_PLUGIN_PLUGIN_2);
			}

			if (orderByComparator != null) {
				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);
			}
			else
			 if (pagination) {
				query.append(PluginPortletPreferencesModelImpl.ORDER_BY_JPQL);
			}

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				if (bindPlugin) {
					qPos.add(plugin);
				}

				if (!pagination) {
					list = (List<PluginPortletPreferences>)QueryUtil.list(q,
							getDialect(), start, end, false);

					Collections.sort(list);

					list = new UnmodifiableList<PluginPortletPreferences>(list);
				}
				else {
					list = (List<PluginPortletPreferences>)QueryUtil.list(q,
							getDialect(), start, end);
				}

				cacheResult(list);

				FinderCacheUtil.putResult(finderPath, finderArgs, list);
			}
			catch (Exception e) {
				FinderCacheUtil.removeResult(finderPath, finderArgs);

				throw processException(e);
			}
			finally {
				closeSession(session);
			}
		}

		return list;
	}

	/**
	 * Returns the first plugin portlet preferences in the ordered set where plugin = &#63;.
	 *
	 * @param plugin the plugin
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the first matching plugin portlet preferences
	 * @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a matching plugin portlet preferences could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences findByPlugin_First(String plugin,
		OrderByComparator orderByComparator)
		throws NoSuchPluginPortletPreferencesException, SystemException {
		PluginPortletPreferences pluginPortletPreferences = fetchByPlugin_First(plugin,
				orderByComparator);

		if (pluginPortletPreferences != null) {
			return pluginPortletPreferences;
		}

		StringBundler msg = new StringBundler(4);

		msg.append(_NO_SUCH_ENTITY_WITH_KEY);

		msg.append("plugin=");
		msg.append(plugin);

		msg.append(StringPool.CLOSE_CURLY_BRACE);

		throw new NoSuchPluginPortletPreferencesException(msg.toString());
	}

	/**
	 * Returns the first plugin portlet preferences in the ordered set where plugin = &#63;.
	 *
	 * @param plugin the plugin
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the first matching plugin portlet preferences, or <code>null</code> if a matching plugin portlet preferences could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences fetchByPlugin_First(String plugin,
		OrderByComparator orderByComparator) throws SystemException {
		List<PluginPortletPreferences> list = findByPlugin(plugin, 0, 1,
				orderByComparator);

		if (!list.isEmpty()) {
			return list.get(0);
		}

		return null;
	}

	/**
	 * Returns the last plugin portlet preferences in the ordered set where plugin = &#63;.
	 *
	 * @param plugin the plugin
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the last matching plugin portlet preferences
	 * @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a matching plugin portlet preferences could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences findByPlugin_Last(String plugin,
		OrderByComparator orderByComparator)
		throws NoSuchPluginPortletPreferencesException, SystemException {
		PluginPortletPreferences pluginPortletPreferences = fetchByPlugin_Last(plugin,
				orderByComparator);

		if (pluginPortletPreferences != null) {
			return pluginPortletPreferences;
		}

		StringBundler msg = new StringBundler(4);

		msg.append(_NO_SUCH_ENTITY_WITH_KEY);

		msg.append("plugin=");
		msg.append(plugin);

		msg.append(StringPool.CLOSE_CURLY_BRACE);

		throw new NoSuchPluginPortletPreferencesException(msg.toString());
	}

	/**
	 * Returns the last plugin portlet preferences in the ordered set where plugin = &#63;.
	 *
	 * @param plugin the plugin
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the last matching plugin portlet preferences, or <code>null</code> if a matching plugin portlet preferences could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences fetchByPlugin_Last(String plugin,
		OrderByComparator orderByComparator) throws SystemException {
		int count = countByPlugin(plugin);

		if (count == 0) {
			return null;
		}

		List<PluginPortletPreferences> list = findByPlugin(plugin, count - 1,
				count, orderByComparator);

		if (!list.isEmpty()) {
			return list.get(0);
		}

		return null;
	}

	/**
	 * Returns the plugin portlet preferenceses before and after the current plugin portlet preferences in the ordered set where plugin = &#63;.
	 *
	 * @param pluginPortletPreferencesId the primary key of the current plugin portlet preferences
	 * @param plugin the plugin
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the previous, current, and next plugin portlet preferences
	 * @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a plugin portlet preferences with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences[] findByPlugin_PrevAndNext(
		long pluginPortletPreferencesId, String plugin,
		OrderByComparator orderByComparator)
		throws NoSuchPluginPortletPreferencesException, SystemException {
		PluginPortletPreferences pluginPortletPreferences = findByPrimaryKey(pluginPortletPreferencesId);

		Session session = null;

		try {
			session = openSession();

			PluginPortletPreferences[] array = new PluginPortletPreferencesImpl[3];

			array[0] = getByPlugin_PrevAndNext(session,
					pluginPortletPreferences, plugin, orderByComparator, true);

			array[1] = pluginPortletPreferences;

			array[2] = getByPlugin_PrevAndNext(session,
					pluginPortletPreferences, plugin, orderByComparator, false);

			return array;
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	protected PluginPortletPreferences getByPlugin_PrevAndNext(
		Session session, PluginPortletPreferences pluginPortletPreferences,
		String plugin, OrderByComparator orderByComparator, boolean previous) {
		StringBundler query = null;

		if (orderByComparator != null) {
			query = new StringBundler(6 +
					(orderByComparator.getOrderByFields().length * 6));
		}
		else {
			query = new StringBundler(3);
		}

		query.append(_SQL_SELECT_PLUGINPORTLETPREFERENCES_WHERE);

		boolean bindPlugin = false;

		if (plugin == null) {
			query.append(_FINDER_COLUMN_PLUGIN_PLUGIN_1);
		}
		else if (plugin.equals(StringPool.BLANK)) {
			query.append(_FINDER_COLUMN_PLUGIN_PLUGIN_3);
		}
		else {
			bindPlugin = true;

			query.append(_FINDER_COLUMN_PLUGIN_PLUGIN_2);
		}

		if (orderByComparator != null) {
			String[] orderByConditionFields = orderByComparator.getOrderByConditionFields();

			if (orderByConditionFields.length > 0) {
				query.append(WHERE_AND);
			}

			for (int i = 0; i < orderByConditionFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByConditionFields[i]);

				if ((i + 1) < orderByConditionFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN_HAS_NEXT);
					}
					else {
						query.append(WHERE_LESSER_THAN_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN);
					}
					else {
						query.append(WHERE_LESSER_THAN);
					}
				}
			}

			query.append(ORDER_BY_CLAUSE);

			String[] orderByFields = orderByComparator.getOrderByFields();

			for (int i = 0; i < orderByFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByFields[i]);

				if ((i + 1) < orderByFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC_HAS_NEXT);
					}
					else {
						query.append(ORDER_BY_DESC_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC);
					}
					else {
						query.append(ORDER_BY_DESC);
					}
				}
			}
		}
		else {
			query.append(PluginPortletPreferencesModelImpl.ORDER_BY_JPQL);
		}

		String sql = query.toString();

		Query q = session.createQuery(sql);

		q.setFirstResult(0);
		q.setMaxResults(2);

		QueryPos qPos = QueryPos.getInstance(q);

		if (bindPlugin) {
			qPos.add(plugin);
		}

		if (orderByComparator != null) {
			Object[] values = orderByComparator.getOrderByConditionValues(pluginPortletPreferences);

			for (Object value : values) {
				qPos.add(value);
			}
		}

		List<PluginPortletPreferences> list = q.list();

		if (list.size() == 2) {
			return list.get(1);
		}
		else {
			return null;
		}
	}

	/**
	 * Removes all the plugin portlet preferenceses where plugin = &#63; from the database.
	 *
	 * @param plugin the plugin
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public void removeByPlugin(String plugin) throws SystemException {
		for (PluginPortletPreferences pluginPortletPreferences : findByPlugin(
				plugin, QueryUtil.ALL_POS, QueryUtil.ALL_POS, null)) {
			remove(pluginPortletPreferences);
		}
	}

	/**
	 * Returns the number of plugin portlet preferenceses where plugin = &#63;.
	 *
	 * @param plugin the plugin
	 * @return the number of matching plugin portlet preferenceses
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public int countByPlugin(String plugin) throws SystemException {
		FinderPath finderPath = FINDER_PATH_COUNT_BY_PLUGIN;

		Object[] finderArgs = new Object[] { plugin };

		Long count = (Long)FinderCacheUtil.getResult(finderPath, finderArgs,
				this);

		if (count == null) {
			StringBundler query = new StringBundler(2);

			query.append(_SQL_COUNT_PLUGINPORTLETPREFERENCES_WHERE);

			boolean bindPlugin = false;

			if (plugin == null) {
				query.append(_FINDER_COLUMN_PLUGIN_PLUGIN_1);
			}
			else if (plugin.equals(StringPool.BLANK)) {
				query.append(_FINDER_COLUMN_PLUGIN_PLUGIN_3);
			}
			else {
				bindPlugin = true;

				query.append(_FINDER_COLUMN_PLUGIN_PLUGIN_2);
			}

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				if (bindPlugin) {
					qPos.add(plugin);
				}

				count = (Long)q.uniqueResult();

				FinderCacheUtil.putResult(finderPath, finderArgs, count);
			}
			catch (Exception e) {
				FinderCacheUtil.removeResult(finderPath, finderArgs);

				throw processException(e);
			}
			finally {
				closeSession(session);
			}
		}

		return count.intValue();
	}

	private static final String _FINDER_COLUMN_PLUGIN_PLUGIN_1 = "pluginPortletPreferences.plugin IS NULL";
	private static final String _FINDER_COLUMN_PLUGIN_PLUGIN_2 = "pluginPortletPreferences.plugin = ?";
	private static final String _FINDER_COLUMN_PLUGIN_PLUGIN_3 = "(pluginPortletPreferences.plugin IS NULL OR pluginPortletPreferences.plugin = '')";
	public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_BY_P_P = new FinderPath(PluginPortletPreferencesModelImpl.ENTITY_CACHE_ENABLED,
			PluginPortletPreferencesModelImpl.FINDER_CACHE_ENABLED,
			PluginPortletPreferencesImpl.class,
			FINDER_CLASS_NAME_LIST_WITH_PAGINATION, "findByP_P",
			new String[] {
				String.class.getName(), String.class.getName(),
				
			Integer.class.getName(), Integer.class.getName(),
				OrderByComparator.class.getName()
			});
	public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_P_P = new FinderPath(PluginPortletPreferencesModelImpl.ENTITY_CACHE_ENABLED,
			PluginPortletPreferencesModelImpl.FINDER_CACHE_ENABLED,
			PluginPortletPreferencesImpl.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "findByP_P",
			new String[] { String.class.getName(), String.class.getName() },
			PluginPortletPreferencesModelImpl.PORTLETID_COLUMN_BITMASK |
			PluginPortletPreferencesModelImpl.PLUGIN_COLUMN_BITMASK);
	public static final FinderPath FINDER_PATH_COUNT_BY_P_P = new FinderPath(PluginPortletPreferencesModelImpl.ENTITY_CACHE_ENABLED,
			PluginPortletPreferencesModelImpl.FINDER_CACHE_ENABLED, Long.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countByP_P",
			new String[] { String.class.getName(), String.class.getName() });

	/**
	 * Returns all the plugin portlet preferenceses where portletId = &#63; and plugin = &#63;.
	 *
	 * @param portletId the portlet ID
	 * @param plugin the plugin
	 * @return the matching plugin portlet preferenceses
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public List<PluginPortletPreferences> findByP_P(String portletId,
		String plugin) throws SystemException {
		return findByP_P(portletId, plugin, QueryUtil.ALL_POS,
			QueryUtil.ALL_POS, null);
	}

	/**
	 * Returns a range of all the plugin portlet preferenceses where portletId = &#63; and plugin = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	 * </p>
	 *
	 * @param portletId the portlet ID
	 * @param plugin the plugin
	 * @param start the lower bound of the range of plugin portlet preferenceses
	 * @param end the upper bound of the range of plugin portlet preferenceses (not inclusive)
	 * @return the range of matching plugin portlet preferenceses
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public List<PluginPortletPreferences> findByP_P(String portletId,
		String plugin, int start, int end) throws SystemException {
		return findByP_P(portletId, plugin, start, end, null);
	}

	/**
	 * Returns an ordered range of all the plugin portlet preferenceses where portletId = &#63; and plugin = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	 * </p>
	 *
	 * @param portletId the portlet ID
	 * @param plugin the plugin
	 * @param start the lower bound of the range of plugin portlet preferenceses
	 * @param end the upper bound of the range of plugin portlet preferenceses (not inclusive)
	 * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	 * @return the ordered range of matching plugin portlet preferenceses
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public List<PluginPortletPreferences> findByP_P(String portletId,
		String plugin, int start, int end, OrderByComparator orderByComparator)
		throws SystemException {
		boolean pagination = true;
		FinderPath finderPath = null;
		Object[] finderArgs = null;

		if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
				(orderByComparator == null)) {
			pagination = false;
			finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_P_P;
			finderArgs = new Object[] { portletId, plugin };
		}
		else {
			finderPath = FINDER_PATH_WITH_PAGINATION_FIND_BY_P_P;
			finderArgs = new Object[] {
					portletId, plugin,
					
					start, end, orderByComparator
				};
		}

		List<PluginPortletPreferences> list = (List<PluginPortletPreferences>)FinderCacheUtil.getResult(finderPath,
				finderArgs, this);

		if ((list != null) && !list.isEmpty()) {
			for (PluginPortletPreferences pluginPortletPreferences : list) {
				if (!Validator.equals(portletId,
							pluginPortletPreferences.getPortletId()) ||
						!Validator.equals(plugin,
							pluginPortletPreferences.getPlugin())) {
					list = null;

					break;
				}
			}
		}

		if (list == null) {
			StringBundler query = null;

			if (orderByComparator != null) {
				query = new StringBundler(4 +
						(orderByComparator.getOrderByFields().length * 3));
			}
			else {
				query = new StringBundler(4);
			}

			query.append(_SQL_SELECT_PLUGINPORTLETPREFERENCES_WHERE);

			boolean bindPortletId = false;

			if (portletId == null) {
				query.append(_FINDER_COLUMN_P_P_PORTLETID_1);
			}
			else if (portletId.equals(StringPool.BLANK)) {
				query.append(_FINDER_COLUMN_P_P_PORTLETID_3);
			}
			else {
				bindPortletId = true;

				query.append(_FINDER_COLUMN_P_P_PORTLETID_2);
			}

			boolean bindPlugin = false;

			if (plugin == null) {
				query.append(_FINDER_COLUMN_P_P_PLUGIN_1);
			}
			else if (plugin.equals(StringPool.BLANK)) {
				query.append(_FINDER_COLUMN_P_P_PLUGIN_3);
			}
			else {
				bindPlugin = true;

				query.append(_FINDER_COLUMN_P_P_PLUGIN_2);
			}

			if (orderByComparator != null) {
				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);
			}
			else
			 if (pagination) {
				query.append(PluginPortletPreferencesModelImpl.ORDER_BY_JPQL);
			}

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				if (bindPortletId) {
					qPos.add(portletId);
				}

				if (bindPlugin) {
					qPos.add(plugin);
				}

				if (!pagination) {
					list = (List<PluginPortletPreferences>)QueryUtil.list(q,
							getDialect(), start, end, false);

					Collections.sort(list);

					list = new UnmodifiableList<PluginPortletPreferences>(list);
				}
				else {
					list = (List<PluginPortletPreferences>)QueryUtil.list(q,
							getDialect(), start, end);
				}

				cacheResult(list);

				FinderCacheUtil.putResult(finderPath, finderArgs, list);
			}
			catch (Exception e) {
				FinderCacheUtil.removeResult(finderPath, finderArgs);

				throw processException(e);
			}
			finally {
				closeSession(session);
			}
		}

		return list;
	}

	/**
	 * Returns the first plugin portlet preferences in the ordered set where portletId = &#63; and plugin = &#63;.
	 *
	 * @param portletId the portlet ID
	 * @param plugin the plugin
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the first matching plugin portlet preferences
	 * @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a matching plugin portlet preferences could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences findByP_P_First(String portletId,
		String plugin, OrderByComparator orderByComparator)
		throws NoSuchPluginPortletPreferencesException, SystemException {
		PluginPortletPreferences pluginPortletPreferences = fetchByP_P_First(portletId,
				plugin, orderByComparator);

		if (pluginPortletPreferences != null) {
			return pluginPortletPreferences;
		}

		StringBundler msg = new StringBundler(6);

		msg.append(_NO_SUCH_ENTITY_WITH_KEY);

		msg.append("portletId=");
		msg.append(portletId);

		msg.append(", plugin=");
		msg.append(plugin);

		msg.append(StringPool.CLOSE_CURLY_BRACE);

		throw new NoSuchPluginPortletPreferencesException(msg.toString());
	}

	/**
	 * Returns the first plugin portlet preferences in the ordered set where portletId = &#63; and plugin = &#63;.
	 *
	 * @param portletId the portlet ID
	 * @param plugin the plugin
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the first matching plugin portlet preferences, or <code>null</code> if a matching plugin portlet preferences could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences fetchByP_P_First(String portletId,
		String plugin, OrderByComparator orderByComparator)
		throws SystemException {
		List<PluginPortletPreferences> list = findByP_P(portletId, plugin, 0,
				1, orderByComparator);

		if (!list.isEmpty()) {
			return list.get(0);
		}

		return null;
	}

	/**
	 * Returns the last plugin portlet preferences in the ordered set where portletId = &#63; and plugin = &#63;.
	 *
	 * @param portletId the portlet ID
	 * @param plugin the plugin
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the last matching plugin portlet preferences
	 * @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a matching plugin portlet preferences could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences findByP_P_Last(String portletId,
		String plugin, OrderByComparator orderByComparator)
		throws NoSuchPluginPortletPreferencesException, SystemException {
		PluginPortletPreferences pluginPortletPreferences = fetchByP_P_Last(portletId,
				plugin, orderByComparator);

		if (pluginPortletPreferences != null) {
			return pluginPortletPreferences;
		}

		StringBundler msg = new StringBundler(6);

		msg.append(_NO_SUCH_ENTITY_WITH_KEY);

		msg.append("portletId=");
		msg.append(portletId);

		msg.append(", plugin=");
		msg.append(plugin);

		msg.append(StringPool.CLOSE_CURLY_BRACE);

		throw new NoSuchPluginPortletPreferencesException(msg.toString());
	}

	/**
	 * Returns the last plugin portlet preferences in the ordered set where portletId = &#63; and plugin = &#63;.
	 *
	 * @param portletId the portlet ID
	 * @param plugin the plugin
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the last matching plugin portlet preferences, or <code>null</code> if a matching plugin portlet preferences could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences fetchByP_P_Last(String portletId,
		String plugin, OrderByComparator orderByComparator)
		throws SystemException {
		int count = countByP_P(portletId, plugin);

		if (count == 0) {
			return null;
		}

		List<PluginPortletPreferences> list = findByP_P(portletId, plugin,
				count - 1, count, orderByComparator);

		if (!list.isEmpty()) {
			return list.get(0);
		}

		return null;
	}

	/**
	 * Returns the plugin portlet preferenceses before and after the current plugin portlet preferences in the ordered set where portletId = &#63; and plugin = &#63;.
	 *
	 * @param pluginPortletPreferencesId the primary key of the current plugin portlet preferences
	 * @param portletId the portlet ID
	 * @param plugin the plugin
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the previous, current, and next plugin portlet preferences
	 * @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a plugin portlet preferences with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences[] findByP_P_PrevAndNext(
		long pluginPortletPreferencesId, String portletId, String plugin,
		OrderByComparator orderByComparator)
		throws NoSuchPluginPortletPreferencesException, SystemException {
		PluginPortletPreferences pluginPortletPreferences = findByPrimaryKey(pluginPortletPreferencesId);

		Session session = null;

		try {
			session = openSession();

			PluginPortletPreferences[] array = new PluginPortletPreferencesImpl[3];

			array[0] = getByP_P_PrevAndNext(session, pluginPortletPreferences,
					portletId, plugin, orderByComparator, true);

			array[1] = pluginPortletPreferences;

			array[2] = getByP_P_PrevAndNext(session, pluginPortletPreferences,
					portletId, plugin, orderByComparator, false);

			return array;
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	protected PluginPortletPreferences getByP_P_PrevAndNext(Session session,
		PluginPortletPreferences pluginPortletPreferences, String portletId,
		String plugin, OrderByComparator orderByComparator, boolean previous) {
		StringBundler query = null;

		if (orderByComparator != null) {
			query = new StringBundler(6 +
					(orderByComparator.getOrderByFields().length * 6));
		}
		else {
			query = new StringBundler(3);
		}

		query.append(_SQL_SELECT_PLUGINPORTLETPREFERENCES_WHERE);

		boolean bindPortletId = false;

		if (portletId == null) {
			query.append(_FINDER_COLUMN_P_P_PORTLETID_1);
		}
		else if (portletId.equals(StringPool.BLANK)) {
			query.append(_FINDER_COLUMN_P_P_PORTLETID_3);
		}
		else {
			bindPortletId = true;

			query.append(_FINDER_COLUMN_P_P_PORTLETID_2);
		}

		boolean bindPlugin = false;

		if (plugin == null) {
			query.append(_FINDER_COLUMN_P_P_PLUGIN_1);
		}
		else if (plugin.equals(StringPool.BLANK)) {
			query.append(_FINDER_COLUMN_P_P_PLUGIN_3);
		}
		else {
			bindPlugin = true;

			query.append(_FINDER_COLUMN_P_P_PLUGIN_2);
		}

		if (orderByComparator != null) {
			String[] orderByConditionFields = orderByComparator.getOrderByConditionFields();

			if (orderByConditionFields.length > 0) {
				query.append(WHERE_AND);
			}

			for (int i = 0; i < orderByConditionFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByConditionFields[i]);

				if ((i + 1) < orderByConditionFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN_HAS_NEXT);
					}
					else {
						query.append(WHERE_LESSER_THAN_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN);
					}
					else {
						query.append(WHERE_LESSER_THAN);
					}
				}
			}

			query.append(ORDER_BY_CLAUSE);

			String[] orderByFields = orderByComparator.getOrderByFields();

			for (int i = 0; i < orderByFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByFields[i]);

				if ((i + 1) < orderByFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC_HAS_NEXT);
					}
					else {
						query.append(ORDER_BY_DESC_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC);
					}
					else {
						query.append(ORDER_BY_DESC);
					}
				}
			}
		}
		else {
			query.append(PluginPortletPreferencesModelImpl.ORDER_BY_JPQL);
		}

		String sql = query.toString();

		Query q = session.createQuery(sql);

		q.setFirstResult(0);
		q.setMaxResults(2);

		QueryPos qPos = QueryPos.getInstance(q);

		if (bindPortletId) {
			qPos.add(portletId);
		}

		if (bindPlugin) {
			qPos.add(plugin);
		}

		if (orderByComparator != null) {
			Object[] values = orderByComparator.getOrderByConditionValues(pluginPortletPreferences);

			for (Object value : values) {
				qPos.add(value);
			}
		}

		List<PluginPortletPreferences> list = q.list();

		if (list.size() == 2) {
			return list.get(1);
		}
		else {
			return null;
		}
	}

	/**
	 * Removes all the plugin portlet preferenceses where portletId = &#63; and plugin = &#63; from the database.
	 *
	 * @param portletId the portlet ID
	 * @param plugin the plugin
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public void removeByP_P(String portletId, String plugin)
		throws SystemException {
		for (PluginPortletPreferences pluginPortletPreferences : findByP_P(
				portletId, plugin, QueryUtil.ALL_POS, QueryUtil.ALL_POS, null)) {
			remove(pluginPortletPreferences);
		}
	}

	/**
	 * Returns the number of plugin portlet preferenceses where portletId = &#63; and plugin = &#63;.
	 *
	 * @param portletId the portlet ID
	 * @param plugin the plugin
	 * @return the number of matching plugin portlet preferenceses
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public int countByP_P(String portletId, String plugin)
		throws SystemException {
		FinderPath finderPath = FINDER_PATH_COUNT_BY_P_P;

		Object[] finderArgs = new Object[] { portletId, plugin };

		Long count = (Long)FinderCacheUtil.getResult(finderPath, finderArgs,
				this);

		if (count == null) {
			StringBundler query = new StringBundler(3);

			query.append(_SQL_COUNT_PLUGINPORTLETPREFERENCES_WHERE);

			boolean bindPortletId = false;

			if (portletId == null) {
				query.append(_FINDER_COLUMN_P_P_PORTLETID_1);
			}
			else if (portletId.equals(StringPool.BLANK)) {
				query.append(_FINDER_COLUMN_P_P_PORTLETID_3);
			}
			else {
				bindPortletId = true;

				query.append(_FINDER_COLUMN_P_P_PORTLETID_2);
			}

			boolean bindPlugin = false;

			if (plugin == null) {
				query.append(_FINDER_COLUMN_P_P_PLUGIN_1);
			}
			else if (plugin.equals(StringPool.BLANK)) {
				query.append(_FINDER_COLUMN_P_P_PLUGIN_3);
			}
			else {
				bindPlugin = true;

				query.append(_FINDER_COLUMN_P_P_PLUGIN_2);
			}

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				if (bindPortletId) {
					qPos.add(portletId);
				}

				if (bindPlugin) {
					qPos.add(plugin);
				}

				count = (Long)q.uniqueResult();

				FinderCacheUtil.putResult(finderPath, finderArgs, count);
			}
			catch (Exception e) {
				FinderCacheUtil.removeResult(finderPath, finderArgs);

				throw processException(e);
			}
			finally {
				closeSession(session);
			}
		}

		return count.intValue();
	}

	private static final String _FINDER_COLUMN_P_P_PORTLETID_1 = "pluginPortletPreferences.portletId IS NULL AND ";
	private static final String _FINDER_COLUMN_P_P_PORTLETID_2 = "pluginPortletPreferences.portletId = ? AND ";
	private static final String _FINDER_COLUMN_P_P_PORTLETID_3 = "(pluginPortletPreferences.portletId IS NULL OR pluginPortletPreferences.portletId = '') AND ";
	private static final String _FINDER_COLUMN_P_P_PLUGIN_1 = "pluginPortletPreferences.plugin IS NULL";
	private static final String _FINDER_COLUMN_P_P_PLUGIN_2 = "pluginPortletPreferences.plugin = ?";
	private static final String _FINDER_COLUMN_P_P_PLUGIN_3 = "(pluginPortletPreferences.plugin IS NULL OR pluginPortletPreferences.plugin = '')";
	public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_BY_O_P_P = new FinderPath(PluginPortletPreferencesModelImpl.ENTITY_CACHE_ENABLED,
			PluginPortletPreferencesModelImpl.FINDER_CACHE_ENABLED,
			PluginPortletPreferencesImpl.class,
			FINDER_CLASS_NAME_LIST_WITH_PAGINATION, "findByO_P_P",
			new String[] {
				Integer.class.getName(), Long.class.getName(),
				String.class.getName(),
				
			Integer.class.getName(), Integer.class.getName(),
				OrderByComparator.class.getName()
			});
	public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_O_P_P = new FinderPath(PluginPortletPreferencesModelImpl.ENTITY_CACHE_ENABLED,
			PluginPortletPreferencesModelImpl.FINDER_CACHE_ENABLED,
			PluginPortletPreferencesImpl.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "findByO_P_P",
			new String[] {
				Integer.class.getName(), Long.class.getName(),
				String.class.getName()
			},
			PluginPortletPreferencesModelImpl.OWNERTYPE_COLUMN_BITMASK |
			PluginPortletPreferencesModelImpl.PLID_COLUMN_BITMASK |
			PluginPortletPreferencesModelImpl.PORTLETID_COLUMN_BITMASK);
	public static final FinderPath FINDER_PATH_COUNT_BY_O_P_P = new FinderPath(PluginPortletPreferencesModelImpl.ENTITY_CACHE_ENABLED,
			PluginPortletPreferencesModelImpl.FINDER_CACHE_ENABLED, Long.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countByO_P_P",
			new String[] {
				Integer.class.getName(), Long.class.getName(),
				String.class.getName()
			});

	/**
	 * Returns all the plugin portlet preferenceses where ownerType = &#63; and plid = &#63; and portletId = &#63;.
	 *
	 * @param ownerType the owner type
	 * @param plid the plid
	 * @param portletId the portlet ID
	 * @return the matching plugin portlet preferenceses
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public List<PluginPortletPreferences> findByO_P_P(int ownerType, long plid,
		String portletId) throws SystemException {
		return findByO_P_P(ownerType, plid, portletId, QueryUtil.ALL_POS,
			QueryUtil.ALL_POS, null);
	}

	/**
	 * Returns a range of all the plugin portlet preferenceses where ownerType = &#63; and plid = &#63; and portletId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	 * </p>
	 *
	 * @param ownerType the owner type
	 * @param plid the plid
	 * @param portletId the portlet ID
	 * @param start the lower bound of the range of plugin portlet preferenceses
	 * @param end the upper bound of the range of plugin portlet preferenceses (not inclusive)
	 * @return the range of matching plugin portlet preferenceses
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public List<PluginPortletPreferences> findByO_P_P(int ownerType, long plid,
		String portletId, int start, int end) throws SystemException {
		return findByO_P_P(ownerType, plid, portletId, start, end, null);
	}

	/**
	 * Returns an ordered range of all the plugin portlet preferenceses where ownerType = &#63; and plid = &#63; and portletId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	 * </p>
	 *
	 * @param ownerType the owner type
	 * @param plid the plid
	 * @param portletId the portlet ID
	 * @param start the lower bound of the range of plugin portlet preferenceses
	 * @param end the upper bound of the range of plugin portlet preferenceses (not inclusive)
	 * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	 * @return the ordered range of matching plugin portlet preferenceses
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public List<PluginPortletPreferences> findByO_P_P(int ownerType, long plid,
		String portletId, int start, int end,
		OrderByComparator orderByComparator) throws SystemException {
		boolean pagination = true;
		FinderPath finderPath = null;
		Object[] finderArgs = null;

		if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
				(orderByComparator == null)) {
			pagination = false;
			finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_O_P_P;
			finderArgs = new Object[] { ownerType, plid, portletId };
		}
		else {
			finderPath = FINDER_PATH_WITH_PAGINATION_FIND_BY_O_P_P;
			finderArgs = new Object[] {
					ownerType, plid, portletId,
					
					start, end, orderByComparator
				};
		}

		List<PluginPortletPreferences> list = (List<PluginPortletPreferences>)FinderCacheUtil.getResult(finderPath,
				finderArgs, this);

		if ((list != null) && !list.isEmpty()) {
			for (PluginPortletPreferences pluginPortletPreferences : list) {
				if ((ownerType != pluginPortletPreferences.getOwnerType()) ||
						(plid != pluginPortletPreferences.getPlid()) ||
						!Validator.equals(portletId,
							pluginPortletPreferences.getPortletId())) {
					list = null;

					break;
				}
			}
		}

		if (list == null) {
			StringBundler query = null;

			if (orderByComparator != null) {
				query = new StringBundler(5 +
						(orderByComparator.getOrderByFields().length * 3));
			}
			else {
				query = new StringBundler(5);
			}

			query.append(_SQL_SELECT_PLUGINPORTLETPREFERENCES_WHERE);

			query.append(_FINDER_COLUMN_O_P_P_OWNERTYPE_2);

			query.append(_FINDER_COLUMN_O_P_P_PLID_2);

			boolean bindPortletId = false;

			if (portletId == null) {
				query.append(_FINDER_COLUMN_O_P_P_PORTLETID_1);
			}
			else if (portletId.equals(StringPool.BLANK)) {
				query.append(_FINDER_COLUMN_O_P_P_PORTLETID_3);
			}
			else {
				bindPortletId = true;

				query.append(_FINDER_COLUMN_O_P_P_PORTLETID_2);
			}

			if (orderByComparator != null) {
				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);
			}
			else
			 if (pagination) {
				query.append(PluginPortletPreferencesModelImpl.ORDER_BY_JPQL);
			}

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(ownerType);

				qPos.add(plid);

				if (bindPortletId) {
					qPos.add(portletId);
				}

				if (!pagination) {
					list = (List<PluginPortletPreferences>)QueryUtil.list(q,
							getDialect(), start, end, false);

					Collections.sort(list);

					list = new UnmodifiableList<PluginPortletPreferences>(list);
				}
				else {
					list = (List<PluginPortletPreferences>)QueryUtil.list(q,
							getDialect(), start, end);
				}

				cacheResult(list);

				FinderCacheUtil.putResult(finderPath, finderArgs, list);
			}
			catch (Exception e) {
				FinderCacheUtil.removeResult(finderPath, finderArgs);

				throw processException(e);
			}
			finally {
				closeSession(session);
			}
		}

		return list;
	}

	/**
	 * Returns the first plugin portlet preferences in the ordered set where ownerType = &#63; and plid = &#63; and portletId = &#63;.
	 *
	 * @param ownerType the owner type
	 * @param plid the plid
	 * @param portletId the portlet ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the first matching plugin portlet preferences
	 * @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a matching plugin portlet preferences could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences findByO_P_P_First(int ownerType, long plid,
		String portletId, OrderByComparator orderByComparator)
		throws NoSuchPluginPortletPreferencesException, SystemException {
		PluginPortletPreferences pluginPortletPreferences = fetchByO_P_P_First(ownerType,
				plid, portletId, orderByComparator);

		if (pluginPortletPreferences != null) {
			return pluginPortletPreferences;
		}

		StringBundler msg = new StringBundler(8);

		msg.append(_NO_SUCH_ENTITY_WITH_KEY);

		msg.append("ownerType=");
		msg.append(ownerType);

		msg.append(", plid=");
		msg.append(plid);

		msg.append(", portletId=");
		msg.append(portletId);

		msg.append(StringPool.CLOSE_CURLY_BRACE);

		throw new NoSuchPluginPortletPreferencesException(msg.toString());
	}

	/**
	 * Returns the first plugin portlet preferences in the ordered set where ownerType = &#63; and plid = &#63; and portletId = &#63;.
	 *
	 * @param ownerType the owner type
	 * @param plid the plid
	 * @param portletId the portlet ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the first matching plugin portlet preferences, or <code>null</code> if a matching plugin portlet preferences could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences fetchByO_P_P_First(int ownerType,
		long plid, String portletId, OrderByComparator orderByComparator)
		throws SystemException {
		List<PluginPortletPreferences> list = findByO_P_P(ownerType, plid,
				portletId, 0, 1, orderByComparator);

		if (!list.isEmpty()) {
			return list.get(0);
		}

		return null;
	}

	/**
	 * Returns the last plugin portlet preferences in the ordered set where ownerType = &#63; and plid = &#63; and portletId = &#63;.
	 *
	 * @param ownerType the owner type
	 * @param plid the plid
	 * @param portletId the portlet ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the last matching plugin portlet preferences
	 * @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a matching plugin portlet preferences could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences findByO_P_P_Last(int ownerType, long plid,
		String portletId, OrderByComparator orderByComparator)
		throws NoSuchPluginPortletPreferencesException, SystemException {
		PluginPortletPreferences pluginPortletPreferences = fetchByO_P_P_Last(ownerType,
				plid, portletId, orderByComparator);

		if (pluginPortletPreferences != null) {
			return pluginPortletPreferences;
		}

		StringBundler msg = new StringBundler(8);

		msg.append(_NO_SUCH_ENTITY_WITH_KEY);

		msg.append("ownerType=");
		msg.append(ownerType);

		msg.append(", plid=");
		msg.append(plid);

		msg.append(", portletId=");
		msg.append(portletId);

		msg.append(StringPool.CLOSE_CURLY_BRACE);

		throw new NoSuchPluginPortletPreferencesException(msg.toString());
	}

	/**
	 * Returns the last plugin portlet preferences in the ordered set where ownerType = &#63; and plid = &#63; and portletId = &#63;.
	 *
	 * @param ownerType the owner type
	 * @param plid the plid
	 * @param portletId the portlet ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the last matching plugin portlet preferences, or <code>null</code> if a matching plugin portlet preferences could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences fetchByO_P_P_Last(int ownerType, long plid,
		String portletId, OrderByComparator orderByComparator)
		throws SystemException {
		int count = countByO_P_P(ownerType, plid, portletId);

		if (count == 0) {
			return null;
		}

		List<PluginPortletPreferences> list = findByO_P_P(ownerType, plid,
				portletId, count - 1, count, orderByComparator);

		if (!list.isEmpty()) {
			return list.get(0);
		}

		return null;
	}

	/**
	 * Returns the plugin portlet preferenceses before and after the current plugin portlet preferences in the ordered set where ownerType = &#63; and plid = &#63; and portletId = &#63;.
	 *
	 * @param pluginPortletPreferencesId the primary key of the current plugin portlet preferences
	 * @param ownerType the owner type
	 * @param plid the plid
	 * @param portletId the portlet ID
	 * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
	 * @return the previous, current, and next plugin portlet preferences
	 * @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a plugin portlet preferences with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences[] findByO_P_P_PrevAndNext(
		long pluginPortletPreferencesId, int ownerType, long plid,
		String portletId, OrderByComparator orderByComparator)
		throws NoSuchPluginPortletPreferencesException, SystemException {
		PluginPortletPreferences pluginPortletPreferences = findByPrimaryKey(pluginPortletPreferencesId);

		Session session = null;

		try {
			session = openSession();

			PluginPortletPreferences[] array = new PluginPortletPreferencesImpl[3];

			array[0] = getByO_P_P_PrevAndNext(session,
					pluginPortletPreferences, ownerType, plid, portletId,
					orderByComparator, true);

			array[1] = pluginPortletPreferences;

			array[2] = getByO_P_P_PrevAndNext(session,
					pluginPortletPreferences, ownerType, plid, portletId,
					orderByComparator, false);

			return array;
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	protected PluginPortletPreferences getByO_P_P_PrevAndNext(Session session,
		PluginPortletPreferences pluginPortletPreferences, int ownerType,
		long plid, String portletId, OrderByComparator orderByComparator,
		boolean previous) {
		StringBundler query = null;

		if (orderByComparator != null) {
			query = new StringBundler(6 +
					(orderByComparator.getOrderByFields().length * 6));
		}
		else {
			query = new StringBundler(3);
		}

		query.append(_SQL_SELECT_PLUGINPORTLETPREFERENCES_WHERE);

		query.append(_FINDER_COLUMN_O_P_P_OWNERTYPE_2);

		query.append(_FINDER_COLUMN_O_P_P_PLID_2);

		boolean bindPortletId = false;

		if (portletId == null) {
			query.append(_FINDER_COLUMN_O_P_P_PORTLETID_1);
		}
		else if (portletId.equals(StringPool.BLANK)) {
			query.append(_FINDER_COLUMN_O_P_P_PORTLETID_3);
		}
		else {
			bindPortletId = true;

			query.append(_FINDER_COLUMN_O_P_P_PORTLETID_2);
		}

		if (orderByComparator != null) {
			String[] orderByConditionFields = orderByComparator.getOrderByConditionFields();

			if (orderByConditionFields.length > 0) {
				query.append(WHERE_AND);
			}

			for (int i = 0; i < orderByConditionFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByConditionFields[i]);

				if ((i + 1) < orderByConditionFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN_HAS_NEXT);
					}
					else {
						query.append(WHERE_LESSER_THAN_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN);
					}
					else {
						query.append(WHERE_LESSER_THAN);
					}
				}
			}

			query.append(ORDER_BY_CLAUSE);

			String[] orderByFields = orderByComparator.getOrderByFields();

			for (int i = 0; i < orderByFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByFields[i]);

				if ((i + 1) < orderByFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC_HAS_NEXT);
					}
					else {
						query.append(ORDER_BY_DESC_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC);
					}
					else {
						query.append(ORDER_BY_DESC);
					}
				}
			}
		}
		else {
			query.append(PluginPortletPreferencesModelImpl.ORDER_BY_JPQL);
		}

		String sql = query.toString();

		Query q = session.createQuery(sql);

		q.setFirstResult(0);
		q.setMaxResults(2);

		QueryPos qPos = QueryPos.getInstance(q);

		qPos.add(ownerType);

		qPos.add(plid);

		if (bindPortletId) {
			qPos.add(portletId);
		}

		if (orderByComparator != null) {
			Object[] values = orderByComparator.getOrderByConditionValues(pluginPortletPreferences);

			for (Object value : values) {
				qPos.add(value);
			}
		}

		List<PluginPortletPreferences> list = q.list();

		if (list.size() == 2) {
			return list.get(1);
		}
		else {
			return null;
		}
	}

	/**
	 * Removes all the plugin portlet preferenceses where ownerType = &#63; and plid = &#63; and portletId = &#63; from the database.
	 *
	 * @param ownerType the owner type
	 * @param plid the plid
	 * @param portletId the portlet ID
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public void removeByO_P_P(int ownerType, long plid, String portletId)
		throws SystemException {
		for (PluginPortletPreferences pluginPortletPreferences : findByO_P_P(
				ownerType, plid, portletId, QueryUtil.ALL_POS,
				QueryUtil.ALL_POS, null)) {
			remove(pluginPortletPreferences);
		}
	}

	/**
	 * Returns the number of plugin portlet preferenceses where ownerType = &#63; and plid = &#63; and portletId = &#63;.
	 *
	 * @param ownerType the owner type
	 * @param plid the plid
	 * @param portletId the portlet ID
	 * @return the number of matching plugin portlet preferenceses
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public int countByO_P_P(int ownerType, long plid, String portletId)
		throws SystemException {
		FinderPath finderPath = FINDER_PATH_COUNT_BY_O_P_P;

		Object[] finderArgs = new Object[] { ownerType, plid, portletId };

		Long count = (Long)FinderCacheUtil.getResult(finderPath, finderArgs,
				this);

		if (count == null) {
			StringBundler query = new StringBundler(4);

			query.append(_SQL_COUNT_PLUGINPORTLETPREFERENCES_WHERE);

			query.append(_FINDER_COLUMN_O_P_P_OWNERTYPE_2);

			query.append(_FINDER_COLUMN_O_P_P_PLID_2);

			boolean bindPortletId = false;

			if (portletId == null) {
				query.append(_FINDER_COLUMN_O_P_P_PORTLETID_1);
			}
			else if (portletId.equals(StringPool.BLANK)) {
				query.append(_FINDER_COLUMN_O_P_P_PORTLETID_3);
			}
			else {
				bindPortletId = true;

				query.append(_FINDER_COLUMN_O_P_P_PORTLETID_2);
			}

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(ownerType);

				qPos.add(plid);

				if (bindPortletId) {
					qPos.add(portletId);
				}

				count = (Long)q.uniqueResult();

				FinderCacheUtil.putResult(finderPath, finderArgs, count);
			}
			catch (Exception e) {
				FinderCacheUtil.removeResult(finderPath, finderArgs);

				throw processException(e);
			}
			finally {
				closeSession(session);
			}
		}

		return count.intValue();
	}

	private static final String _FINDER_COLUMN_O_P_P_OWNERTYPE_2 = "pluginPortletPreferences.ownerType = ? AND ";
	private static final String _FINDER_COLUMN_O_P_P_PLID_2 = "pluginPortletPreferences.plid = ? AND ";
	private static final String _FINDER_COLUMN_O_P_P_PORTLETID_1 = "pluginPortletPreferences.portletId IS NULL";
	private static final String _FINDER_COLUMN_O_P_P_PORTLETID_2 = "pluginPortletPreferences.portletId = ?";
	private static final String _FINDER_COLUMN_O_P_P_PORTLETID_3 = "(pluginPortletPreferences.portletId IS NULL OR pluginPortletPreferences.portletId = '')";
	public static final FinderPath FINDER_PATH_FETCH_BY_O_O_P_P_P = new FinderPath(PluginPortletPreferencesModelImpl.ENTITY_CACHE_ENABLED,
			PluginPortletPreferencesModelImpl.FINDER_CACHE_ENABLED,
			PluginPortletPreferencesImpl.class, FINDER_CLASS_NAME_ENTITY,
			"fetchByO_O_P_P_P",
			new String[] {
				Long.class.getName(), Integer.class.getName(),
				Long.class.getName(), String.class.getName(),
				String.class.getName()
			},
			PluginPortletPreferencesModelImpl.OWNERID_COLUMN_BITMASK |
			PluginPortletPreferencesModelImpl.OWNERTYPE_COLUMN_BITMASK |
			PluginPortletPreferencesModelImpl.PLID_COLUMN_BITMASK |
			PluginPortletPreferencesModelImpl.PORTLETID_COLUMN_BITMASK |
			PluginPortletPreferencesModelImpl.PLUGIN_COLUMN_BITMASK);
	public static final FinderPath FINDER_PATH_COUNT_BY_O_O_P_P_P = new FinderPath(PluginPortletPreferencesModelImpl.ENTITY_CACHE_ENABLED,
			PluginPortletPreferencesModelImpl.FINDER_CACHE_ENABLED, Long.class,
			FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countByO_O_P_P_P",
			new String[] {
				Long.class.getName(), Integer.class.getName(),
				Long.class.getName(), String.class.getName(),
				String.class.getName()
			});

	/**
	 * Returns the plugin portlet preferences where ownerId = &#63; and ownerType = &#63; and plid = &#63; and portletId = &#63; and plugin = &#63; or throws a {@link it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException} if it could not be found.
	 *
	 * @param ownerId the owner ID
	 * @param ownerType the owner type
	 * @param plid the plid
	 * @param portletId the portlet ID
	 * @param plugin the plugin
	 * @return the matching plugin portlet preferences
	 * @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a matching plugin portlet preferences could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences findByO_O_P_P_P(long ownerId,
		int ownerType, long plid, String portletId, String plugin)
		throws NoSuchPluginPortletPreferencesException, SystemException {
		PluginPortletPreferences pluginPortletPreferences = fetchByO_O_P_P_P(ownerId,
				ownerType, plid, portletId, plugin);

		if (pluginPortletPreferences == null) {
			StringBundler msg = new StringBundler(12);

			msg.append(_NO_SUCH_ENTITY_WITH_KEY);

			msg.append("ownerId=");
			msg.append(ownerId);

			msg.append(", ownerType=");
			msg.append(ownerType);

			msg.append(", plid=");
			msg.append(plid);

			msg.append(", portletId=");
			msg.append(portletId);

			msg.append(", plugin=");
			msg.append(plugin);

			msg.append(StringPool.CLOSE_CURLY_BRACE);

			if (_log.isWarnEnabled()) {
				_log.warn(msg.toString());
			}

			throw new NoSuchPluginPortletPreferencesException(msg.toString());
		}

		return pluginPortletPreferences;
	}

	/**
	 * Returns the plugin portlet preferences where ownerId = &#63; and ownerType = &#63; and plid = &#63; and portletId = &#63; and plugin = &#63; or returns <code>null</code> if it could not be found. Uses the finder cache.
	 *
	 * @param ownerId the owner ID
	 * @param ownerType the owner type
	 * @param plid the plid
	 * @param portletId the portlet ID
	 * @param plugin the plugin
	 * @return the matching plugin portlet preferences, or <code>null</code> if a matching plugin portlet preferences could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences fetchByO_O_P_P_P(long ownerId,
		int ownerType, long plid, String portletId, String plugin)
		throws SystemException {
		return fetchByO_O_P_P_P(ownerId, ownerType, plid, portletId, plugin,
			true);
	}

	/**
	 * Returns the plugin portlet preferences where ownerId = &#63; and ownerType = &#63; and plid = &#63; and portletId = &#63; and plugin = &#63; or returns <code>null</code> if it could not be found, optionally using the finder cache.
	 *
	 * @param ownerId the owner ID
	 * @param ownerType the owner type
	 * @param plid the plid
	 * @param portletId the portlet ID
	 * @param plugin the plugin
	 * @param retrieveFromCache whether to use the finder cache
	 * @return the matching plugin portlet preferences, or <code>null</code> if a matching plugin portlet preferences could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences fetchByO_O_P_P_P(long ownerId,
		int ownerType, long plid, String portletId, String plugin,
		boolean retrieveFromCache) throws SystemException {
		Object[] finderArgs = new Object[] {
				ownerId, ownerType, plid, portletId, plugin
			};

		Object result = null;

		if (retrieveFromCache) {
			result = FinderCacheUtil.getResult(FINDER_PATH_FETCH_BY_O_O_P_P_P,
					finderArgs, this);
		}

		if (result instanceof PluginPortletPreferences) {
			PluginPortletPreferences pluginPortletPreferences = (PluginPortletPreferences)result;

			if ((ownerId != pluginPortletPreferences.getOwnerId()) ||
					(ownerType != pluginPortletPreferences.getOwnerType()) ||
					(plid != pluginPortletPreferences.getPlid()) ||
					!Validator.equals(portletId,
						pluginPortletPreferences.getPortletId()) ||
					!Validator.equals(plugin,
						pluginPortletPreferences.getPlugin())) {
				result = null;
			}
		}

		if (result == null) {
			StringBundler query = new StringBundler(7);

			query.append(_SQL_SELECT_PLUGINPORTLETPREFERENCES_WHERE);

			query.append(_FINDER_COLUMN_O_O_P_P_P_OWNERID_2);

			query.append(_FINDER_COLUMN_O_O_P_P_P_OWNERTYPE_2);

			query.append(_FINDER_COLUMN_O_O_P_P_P_PLID_2);

			boolean bindPortletId = false;

			if (portletId == null) {
				query.append(_FINDER_COLUMN_O_O_P_P_P_PORTLETID_1);
			}
			else if (portletId.equals(StringPool.BLANK)) {
				query.append(_FINDER_COLUMN_O_O_P_P_P_PORTLETID_3);
			}
			else {
				bindPortletId = true;

				query.append(_FINDER_COLUMN_O_O_P_P_P_PORTLETID_2);
			}

			boolean bindPlugin = false;

			if (plugin == null) {
				query.append(_FINDER_COLUMN_O_O_P_P_P_PLUGIN_1);
			}
			else if (plugin.equals(StringPool.BLANK)) {
				query.append(_FINDER_COLUMN_O_O_P_P_P_PLUGIN_3);
			}
			else {
				bindPlugin = true;

				query.append(_FINDER_COLUMN_O_O_P_P_P_PLUGIN_2);
			}

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(ownerId);

				qPos.add(ownerType);

				qPos.add(plid);

				if (bindPortletId) {
					qPos.add(portletId);
				}

				if (bindPlugin) {
					qPos.add(plugin);
				}

				List<PluginPortletPreferences> list = q.list();

				if (list.isEmpty()) {
					FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_O_O_P_P_P,
						finderArgs, list);
				}
				else {
					PluginPortletPreferences pluginPortletPreferences = list.get(0);

					result = pluginPortletPreferences;

					cacheResult(pluginPortletPreferences);

					if ((pluginPortletPreferences.getOwnerId() != ownerId) ||
							(pluginPortletPreferences.getOwnerType() != ownerType) ||
							(pluginPortletPreferences.getPlid() != plid) ||
							(pluginPortletPreferences.getPortletId() == null) ||
							!pluginPortletPreferences.getPortletId()
														 .equals(portletId) ||
							(pluginPortletPreferences.getPlugin() == null) ||
							!pluginPortletPreferences.getPlugin().equals(plugin)) {
						FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_O_O_P_P_P,
							finderArgs, pluginPortletPreferences);
					}
				}
			}
			catch (Exception e) {
				FinderCacheUtil.removeResult(FINDER_PATH_FETCH_BY_O_O_P_P_P,
					finderArgs);

				throw processException(e);
			}
			finally {
				closeSession(session);
			}
		}

		if (result instanceof List<?>) {
			return null;
		}
		else {
			return (PluginPortletPreferences)result;
		}
	}

	/**
	 * Removes the plugin portlet preferences where ownerId = &#63; and ownerType = &#63; and plid = &#63; and portletId = &#63; and plugin = &#63; from the database.
	 *
	 * @param ownerId the owner ID
	 * @param ownerType the owner type
	 * @param plid the plid
	 * @param portletId the portlet ID
	 * @param plugin the plugin
	 * @return the plugin portlet preferences that was removed
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences removeByO_O_P_P_P(long ownerId,
		int ownerType, long plid, String portletId, String plugin)
		throws NoSuchPluginPortletPreferencesException, SystemException {
		PluginPortletPreferences pluginPortletPreferences = findByO_O_P_P_P(ownerId,
				ownerType, plid, portletId, plugin);

		return remove(pluginPortletPreferences);
	}

	/**
	 * Returns the number of plugin portlet preferenceses where ownerId = &#63; and ownerType = &#63; and plid = &#63; and portletId = &#63; and plugin = &#63;.
	 *
	 * @param ownerId the owner ID
	 * @param ownerType the owner type
	 * @param plid the plid
	 * @param portletId the portlet ID
	 * @param plugin the plugin
	 * @return the number of matching plugin portlet preferenceses
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public int countByO_O_P_P_P(long ownerId, int ownerType, long plid,
		String portletId, String plugin) throws SystemException {
		FinderPath finderPath = FINDER_PATH_COUNT_BY_O_O_P_P_P;

		Object[] finderArgs = new Object[] {
				ownerId, ownerType, plid, portletId, plugin
			};

		Long count = (Long)FinderCacheUtil.getResult(finderPath, finderArgs,
				this);

		if (count == null) {
			StringBundler query = new StringBundler(6);

			query.append(_SQL_COUNT_PLUGINPORTLETPREFERENCES_WHERE);

			query.append(_FINDER_COLUMN_O_O_P_P_P_OWNERID_2);

			query.append(_FINDER_COLUMN_O_O_P_P_P_OWNERTYPE_2);

			query.append(_FINDER_COLUMN_O_O_P_P_P_PLID_2);

			boolean bindPortletId = false;

			if (portletId == null) {
				query.append(_FINDER_COLUMN_O_O_P_P_P_PORTLETID_1);
			}
			else if (portletId.equals(StringPool.BLANK)) {
				query.append(_FINDER_COLUMN_O_O_P_P_P_PORTLETID_3);
			}
			else {
				bindPortletId = true;

				query.append(_FINDER_COLUMN_O_O_P_P_P_PORTLETID_2);
			}

			boolean bindPlugin = false;

			if (plugin == null) {
				query.append(_FINDER_COLUMN_O_O_P_P_P_PLUGIN_1);
			}
			else if (plugin.equals(StringPool.BLANK)) {
				query.append(_FINDER_COLUMN_O_O_P_P_P_PLUGIN_3);
			}
			else {
				bindPlugin = true;

				query.append(_FINDER_COLUMN_O_O_P_P_P_PLUGIN_2);
			}

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(ownerId);

				qPos.add(ownerType);

				qPos.add(plid);

				if (bindPortletId) {
					qPos.add(portletId);
				}

				if (bindPlugin) {
					qPos.add(plugin);
				}

				count = (Long)q.uniqueResult();

				FinderCacheUtil.putResult(finderPath, finderArgs, count);
			}
			catch (Exception e) {
				FinderCacheUtil.removeResult(finderPath, finderArgs);

				throw processException(e);
			}
			finally {
				closeSession(session);
			}
		}

		return count.intValue();
	}

	private static final String _FINDER_COLUMN_O_O_P_P_P_OWNERID_2 = "pluginPortletPreferences.ownerId = ? AND ";
	private static final String _FINDER_COLUMN_O_O_P_P_P_OWNERTYPE_2 = "pluginPortletPreferences.ownerType = ? AND ";
	private static final String _FINDER_COLUMN_O_O_P_P_P_PLID_2 = "pluginPortletPreferences.plid = ? AND ";
	private static final String _FINDER_COLUMN_O_O_P_P_P_PORTLETID_1 = "pluginPortletPreferences.portletId IS NULL AND ";
	private static final String _FINDER_COLUMN_O_O_P_P_P_PORTLETID_2 = "pluginPortletPreferences.portletId = ? AND ";
	private static final String _FINDER_COLUMN_O_O_P_P_P_PORTLETID_3 = "(pluginPortletPreferences.portletId IS NULL OR pluginPortletPreferences.portletId = '') AND ";
	private static final String _FINDER_COLUMN_O_O_P_P_P_PLUGIN_1 = "pluginPortletPreferences.plugin IS NULL";
	private static final String _FINDER_COLUMN_O_O_P_P_P_PLUGIN_2 = "pluginPortletPreferences.plugin = ?";
	private static final String _FINDER_COLUMN_O_O_P_P_P_PLUGIN_3 = "(pluginPortletPreferences.plugin IS NULL OR pluginPortletPreferences.plugin = '')";

	public PluginPortletPreferencesPersistenceImpl() {
		setModelClass(PluginPortletPreferences.class);
	}

	/**
	 * Caches the plugin portlet preferences in the entity cache if it is enabled.
	 *
	 * @param pluginPortletPreferences the plugin portlet preferences
	 */
	@Override
	public void cacheResult(PluginPortletPreferences pluginPortletPreferences) {
		EntityCacheUtil.putResult(PluginPortletPreferencesModelImpl.ENTITY_CACHE_ENABLED,
			PluginPortletPreferencesImpl.class,
			pluginPortletPreferences.getPrimaryKey(), pluginPortletPreferences);

		FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_O_O_P_P_P,
			new Object[] {
				pluginPortletPreferences.getOwnerId(),
				pluginPortletPreferences.getOwnerType(),
				pluginPortletPreferences.getPlid(),
				pluginPortletPreferences.getPortletId(),
				pluginPortletPreferences.getPlugin()
			}, pluginPortletPreferences);

		pluginPortletPreferences.resetOriginalValues();
	}

	/**
	 * Caches the plugin portlet preferenceses in the entity cache if it is enabled.
	 *
	 * @param pluginPortletPreferenceses the plugin portlet preferenceses
	 */
	@Override
	public void cacheResult(
		List<PluginPortletPreferences> pluginPortletPreferenceses) {
		for (PluginPortletPreferences pluginPortletPreferences : pluginPortletPreferenceses) {
			if (EntityCacheUtil.getResult(
						PluginPortletPreferencesModelImpl.ENTITY_CACHE_ENABLED,
						PluginPortletPreferencesImpl.class,
						pluginPortletPreferences.getPrimaryKey()) == null) {
				cacheResult(pluginPortletPreferences);
			}
			else {
				pluginPortletPreferences.resetOriginalValues();
			}
		}
	}

	/**
	 * Clears the cache for all plugin portlet preferenceses.
	 *
	 * <p>
	 * The {@link com.liferay.portal.kernel.dao.orm.EntityCache} and {@link com.liferay.portal.kernel.dao.orm.FinderCache} are both cleared by this method.
	 * </p>
	 */
	@Override
	public void clearCache() {
		if (_HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE) {
			CacheRegistryUtil.clear(PluginPortletPreferencesImpl.class.getName());
		}

		EntityCacheUtil.clearCache(PluginPortletPreferencesImpl.class.getName());

		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_ENTITY);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
	}

	/**
	 * Clears the cache for the plugin portlet preferences.
	 *
	 * <p>
	 * The {@link com.liferay.portal.kernel.dao.orm.EntityCache} and {@link com.liferay.portal.kernel.dao.orm.FinderCache} are both cleared by this method.
	 * </p>
	 */
	@Override
	public void clearCache(PluginPortletPreferences pluginPortletPreferences) {
		EntityCacheUtil.removeResult(PluginPortletPreferencesModelImpl.ENTITY_CACHE_ENABLED,
			PluginPortletPreferencesImpl.class,
			pluginPortletPreferences.getPrimaryKey());

		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);

		clearUniqueFindersCache(pluginPortletPreferences);
	}

	@Override
	public void clearCache(
		List<PluginPortletPreferences> pluginPortletPreferenceses) {
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);

		for (PluginPortletPreferences pluginPortletPreferences : pluginPortletPreferenceses) {
			EntityCacheUtil.removeResult(PluginPortletPreferencesModelImpl.ENTITY_CACHE_ENABLED,
				PluginPortletPreferencesImpl.class,
				pluginPortletPreferences.getPrimaryKey());

			clearUniqueFindersCache(pluginPortletPreferences);
		}
	}

	protected void cacheUniqueFindersCache(
		PluginPortletPreferences pluginPortletPreferences) {
		if (pluginPortletPreferences.isNew()) {
			Object[] args = new Object[] {
					pluginPortletPreferences.getOwnerId(),
					pluginPortletPreferences.getOwnerType(),
					pluginPortletPreferences.getPlid(),
					pluginPortletPreferences.getPortletId(),
					pluginPortletPreferences.getPlugin()
				};

			FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_O_O_P_P_P, args,
				Long.valueOf(1));
			FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_O_O_P_P_P, args,
				pluginPortletPreferences);
		}
		else {
			PluginPortletPreferencesModelImpl pluginPortletPreferencesModelImpl = (PluginPortletPreferencesModelImpl)pluginPortletPreferences;

			if ((pluginPortletPreferencesModelImpl.getColumnBitmask() &
					FINDER_PATH_FETCH_BY_O_O_P_P_P.getColumnBitmask()) != 0) {
				Object[] args = new Object[] {
						pluginPortletPreferences.getOwnerId(),
						pluginPortletPreferences.getOwnerType(),
						pluginPortletPreferences.getPlid(),
						pluginPortletPreferences.getPortletId(),
						pluginPortletPreferences.getPlugin()
					};

				FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_O_O_P_P_P, args,
					Long.valueOf(1));
				FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_O_O_P_P_P, args,
					pluginPortletPreferences);
			}
		}
	}

	protected void clearUniqueFindersCache(
		PluginPortletPreferences pluginPortletPreferences) {
		PluginPortletPreferencesModelImpl pluginPortletPreferencesModelImpl = (PluginPortletPreferencesModelImpl)pluginPortletPreferences;

		Object[] args = new Object[] {
				pluginPortletPreferences.getOwnerId(),
				pluginPortletPreferences.getOwnerType(),
				pluginPortletPreferences.getPlid(),
				pluginPortletPreferences.getPortletId(),
				pluginPortletPreferences.getPlugin()
			};

		FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_O_O_P_P_P, args);
		FinderCacheUtil.removeResult(FINDER_PATH_FETCH_BY_O_O_P_P_P, args);

		if ((pluginPortletPreferencesModelImpl.getColumnBitmask() &
				FINDER_PATH_FETCH_BY_O_O_P_P_P.getColumnBitmask()) != 0) {
			args = new Object[] {
					pluginPortletPreferencesModelImpl.getOriginalOwnerId(),
					pluginPortletPreferencesModelImpl.getOriginalOwnerType(),
					pluginPortletPreferencesModelImpl.getOriginalPlid(),
					pluginPortletPreferencesModelImpl.getOriginalPortletId(),
					pluginPortletPreferencesModelImpl.getOriginalPlugin()
				};

			FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_O_O_P_P_P, args);
			FinderCacheUtil.removeResult(FINDER_PATH_FETCH_BY_O_O_P_P_P, args);
		}
	}

	/**
	 * Creates a new plugin portlet preferences with the primary key. Does not add the plugin portlet preferences to the database.
	 *
	 * @param pluginPortletPreferencesId the primary key for the new plugin portlet preferences
	 * @return the new plugin portlet preferences
	 */
	@Override
	public PluginPortletPreferences create(long pluginPortletPreferencesId) {
		PluginPortletPreferences pluginPortletPreferences = new PluginPortletPreferencesImpl();

		pluginPortletPreferences.setNew(true);
		pluginPortletPreferences.setPrimaryKey(pluginPortletPreferencesId);

		return pluginPortletPreferences;
	}

	/**
	 * Removes the plugin portlet preferences with the primary key from the database. Also notifies the appropriate model listeners.
	 *
	 * @param pluginPortletPreferencesId the primary key of the plugin portlet preferences
	 * @return the plugin portlet preferences that was removed
	 * @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a plugin portlet preferences with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences remove(long pluginPortletPreferencesId)
		throws NoSuchPluginPortletPreferencesException, SystemException {
		return remove((Serializable)pluginPortletPreferencesId);
	}

	/**
	 * Removes the plugin portlet preferences with the primary key from the database. Also notifies the appropriate model listeners.
	 *
	 * @param primaryKey the primary key of the plugin portlet preferences
	 * @return the plugin portlet preferences that was removed
	 * @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a plugin portlet preferences with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences remove(Serializable primaryKey)
		throws NoSuchPluginPortletPreferencesException, SystemException {
		Session session = null;

		try {
			session = openSession();

			PluginPortletPreferences pluginPortletPreferences = (PluginPortletPreferences)session.get(PluginPortletPreferencesImpl.class,
					primaryKey);

			if (pluginPortletPreferences == null) {
				if (_log.isWarnEnabled()) {
					_log.warn(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY + primaryKey);
				}

				throw new NoSuchPluginPortletPreferencesException(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY +
					primaryKey);
			}

			return remove(pluginPortletPreferences);
		}
		catch (NoSuchPluginPortletPreferencesException nsee) {
			throw nsee;
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	@Override
	protected PluginPortletPreferences removeImpl(
		PluginPortletPreferences pluginPortletPreferences)
		throws SystemException {
		pluginPortletPreferences = toUnwrappedModel(pluginPortletPreferences);

		Session session = null;

		try {
			session = openSession();

			if (!session.contains(pluginPortletPreferences)) {
				pluginPortletPreferences = (PluginPortletPreferences)session.get(PluginPortletPreferencesImpl.class,
						pluginPortletPreferences.getPrimaryKeyObj());
			}

			if (pluginPortletPreferences != null) {
				session.delete(pluginPortletPreferences);
			}
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}

		if (pluginPortletPreferences != null) {
			clearCache(pluginPortletPreferences);
		}

		return pluginPortletPreferences;
	}

	@Override
	public PluginPortletPreferences updateImpl(
		it.tref.liferay.mapit.map.model.PluginPortletPreferences pluginPortletPreferences)
		throws SystemException {
		pluginPortletPreferences = toUnwrappedModel(pluginPortletPreferences);

		boolean isNew = pluginPortletPreferences.isNew();

		PluginPortletPreferencesModelImpl pluginPortletPreferencesModelImpl = (PluginPortletPreferencesModelImpl)pluginPortletPreferences;

		Session session = null;

		try {
			session = openSession();

			if (pluginPortletPreferences.isNew()) {
				session.save(pluginPortletPreferences);

				pluginPortletPreferences.setNew(false);
			}
			else {
				session.merge(pluginPortletPreferences);
			}
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}

		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);

		if (isNew || !PluginPortletPreferencesModelImpl.COLUMN_BITMASK_ENABLED) {
			FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
		}

		else {
			if ((pluginPortletPreferencesModelImpl.getColumnBitmask() &
					FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_PLUGIN.getColumnBitmask()) != 0) {
				Object[] args = new Object[] {
						pluginPortletPreferencesModelImpl.getOriginalPlugin()
					};

				FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_PLUGIN, args);
				FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_PLUGIN,
					args);

				args = new Object[] {
						pluginPortletPreferencesModelImpl.getPlugin()
					};

				FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_PLUGIN, args);
				FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_PLUGIN,
					args);
			}

			if ((pluginPortletPreferencesModelImpl.getColumnBitmask() &
					FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_P_P.getColumnBitmask()) != 0) {
				Object[] args = new Object[] {
						pluginPortletPreferencesModelImpl.getOriginalPortletId(),
						pluginPortletPreferencesModelImpl.getOriginalPlugin()
					};

				FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_P_P, args);
				FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_P_P,
					args);

				args = new Object[] {
						pluginPortletPreferencesModelImpl.getPortletId(),
						pluginPortletPreferencesModelImpl.getPlugin()
					};

				FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_P_P, args);
				FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_P_P,
					args);
			}

			if ((pluginPortletPreferencesModelImpl.getColumnBitmask() &
					FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_O_P_P.getColumnBitmask()) != 0) {
				Object[] args = new Object[] {
						pluginPortletPreferencesModelImpl.getOriginalOwnerType(),
						pluginPortletPreferencesModelImpl.getOriginalPlid(),
						pluginPortletPreferencesModelImpl.getOriginalPortletId()
					};

				FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_O_P_P, args);
				FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_O_P_P,
					args);

				args = new Object[] {
						pluginPortletPreferencesModelImpl.getOwnerType(),
						pluginPortletPreferencesModelImpl.getPlid(),
						pluginPortletPreferencesModelImpl.getPortletId()
					};

				FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_O_P_P, args);
				FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_O_P_P,
					args);
			}
		}

		EntityCacheUtil.putResult(PluginPortletPreferencesModelImpl.ENTITY_CACHE_ENABLED,
			PluginPortletPreferencesImpl.class,
			pluginPortletPreferences.getPrimaryKey(), pluginPortletPreferences);

		clearUniqueFindersCache(pluginPortletPreferences);
		cacheUniqueFindersCache(pluginPortletPreferences);

		return pluginPortletPreferences;
	}

	protected PluginPortletPreferences toUnwrappedModel(
		PluginPortletPreferences pluginPortletPreferences) {
		if (pluginPortletPreferences instanceof PluginPortletPreferencesImpl) {
			return pluginPortletPreferences;
		}

		PluginPortletPreferencesImpl pluginPortletPreferencesImpl = new PluginPortletPreferencesImpl();

		pluginPortletPreferencesImpl.setNew(pluginPortletPreferences.isNew());
		pluginPortletPreferencesImpl.setPrimaryKey(pluginPortletPreferences.getPrimaryKey());

		pluginPortletPreferencesImpl.setPluginPortletPreferencesId(pluginPortletPreferences.getPluginPortletPreferencesId());
		pluginPortletPreferencesImpl.setOwnerId(pluginPortletPreferences.getOwnerId());
		pluginPortletPreferencesImpl.setOwnerType(pluginPortletPreferences.getOwnerType());
		pluginPortletPreferencesImpl.setPlid(pluginPortletPreferences.getPlid());
		pluginPortletPreferencesImpl.setPortletId(pluginPortletPreferences.getPortletId());
		pluginPortletPreferencesImpl.setPlugin(pluginPortletPreferences.getPlugin());
		pluginPortletPreferencesImpl.setPreferences(pluginPortletPreferences.getPreferences());

		return pluginPortletPreferencesImpl;
	}

	/**
	 * Returns the plugin portlet preferences with the primary key or throws a {@link com.liferay.portal.NoSuchModelException} if it could not be found.
	 *
	 * @param primaryKey the primary key of the plugin portlet preferences
	 * @return the plugin portlet preferences
	 * @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a plugin portlet preferences with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences findByPrimaryKey(Serializable primaryKey)
		throws NoSuchPluginPortletPreferencesException, SystemException {
		PluginPortletPreferences pluginPortletPreferences = fetchByPrimaryKey(primaryKey);

		if (pluginPortletPreferences == null) {
			if (_log.isWarnEnabled()) {
				_log.warn(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY + primaryKey);
			}

			throw new NoSuchPluginPortletPreferencesException(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY +
				primaryKey);
		}

		return pluginPortletPreferences;
	}

	/**
	 * Returns the plugin portlet preferences with the primary key or throws a {@link it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException} if it could not be found.
	 *
	 * @param pluginPortletPreferencesId the primary key of the plugin portlet preferences
	 * @return the plugin portlet preferences
	 * @throws it.tref.liferay.mapit.map.NoSuchPluginPortletPreferencesException if a plugin portlet preferences with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences findByPrimaryKey(
		long pluginPortletPreferencesId)
		throws NoSuchPluginPortletPreferencesException, SystemException {
		return findByPrimaryKey((Serializable)pluginPortletPreferencesId);
	}

	/**
	 * Returns the plugin portlet preferences with the primary key or returns <code>null</code> if it could not be found.
	 *
	 * @param primaryKey the primary key of the plugin portlet preferences
	 * @return the plugin portlet preferences, or <code>null</code> if a plugin portlet preferences with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences fetchByPrimaryKey(Serializable primaryKey)
		throws SystemException {
		PluginPortletPreferences pluginPortletPreferences = (PluginPortletPreferences)EntityCacheUtil.getResult(PluginPortletPreferencesModelImpl.ENTITY_CACHE_ENABLED,
				PluginPortletPreferencesImpl.class, primaryKey);

		if (pluginPortletPreferences == _nullPluginPortletPreferences) {
			return null;
		}

		if (pluginPortletPreferences == null) {
			Session session = null;

			try {
				session = openSession();

				pluginPortletPreferences = (PluginPortletPreferences)session.get(PluginPortletPreferencesImpl.class,
						primaryKey);

				if (pluginPortletPreferences != null) {
					cacheResult(pluginPortletPreferences);
				}
				else {
					EntityCacheUtil.putResult(PluginPortletPreferencesModelImpl.ENTITY_CACHE_ENABLED,
						PluginPortletPreferencesImpl.class, primaryKey,
						_nullPluginPortletPreferences);
				}
			}
			catch (Exception e) {
				EntityCacheUtil.removeResult(PluginPortletPreferencesModelImpl.ENTITY_CACHE_ENABLED,
					PluginPortletPreferencesImpl.class, primaryKey);

				throw processException(e);
			}
			finally {
				closeSession(session);
			}
		}

		return pluginPortletPreferences;
	}

	/**
	 * Returns the plugin portlet preferences with the primary key or returns <code>null</code> if it could not be found.
	 *
	 * @param pluginPortletPreferencesId the primary key of the plugin portlet preferences
	 * @return the plugin portlet preferences, or <code>null</code> if a plugin portlet preferences with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public PluginPortletPreferences fetchByPrimaryKey(
		long pluginPortletPreferencesId) throws SystemException {
		return fetchByPrimaryKey((Serializable)pluginPortletPreferencesId);
	}

	/**
	 * Returns all the plugin portlet preferenceses.
	 *
	 * @return the plugin portlet preferenceses
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public List<PluginPortletPreferences> findAll() throws SystemException {
		return findAll(QueryUtil.ALL_POS, QueryUtil.ALL_POS, null);
	}

	/**
	 * Returns a range of all the plugin portlet preferenceses.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	 * </p>
	 *
	 * @param start the lower bound of the range of plugin portlet preferenceses
	 * @param end the upper bound of the range of plugin portlet preferenceses (not inclusive)
	 * @return the range of plugin portlet preferenceses
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public List<PluginPortletPreferences> findAll(int start, int end)
		throws SystemException {
		return findAll(start, end, null);
	}

	/**
	 * Returns an ordered range of all the plugin portlet preferenceses.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link it.tref.liferay.mapit.map.model.impl.PluginPortletPreferencesModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
	 * </p>
	 *
	 * @param start the lower bound of the range of plugin portlet preferenceses
	 * @param end the upper bound of the range of plugin portlet preferenceses (not inclusive)
	 * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
	 * @return the ordered range of plugin portlet preferenceses
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public List<PluginPortletPreferences> findAll(int start, int end,
		OrderByComparator orderByComparator) throws SystemException {
		boolean pagination = true;
		FinderPath finderPath = null;
		Object[] finderArgs = null;

		if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
				(orderByComparator == null)) {
			pagination = false;
			finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_ALL;
			finderArgs = FINDER_ARGS_EMPTY;
		}
		else {
			finderPath = FINDER_PATH_WITH_PAGINATION_FIND_ALL;
			finderArgs = new Object[] { start, end, orderByComparator };
		}

		List<PluginPortletPreferences> list = (List<PluginPortletPreferences>)FinderCacheUtil.getResult(finderPath,
				finderArgs, this);

		if (list == null) {
			StringBundler query = null;
			String sql = null;

			if (orderByComparator != null) {
				query = new StringBundler(2 +
						(orderByComparator.getOrderByFields().length * 3));

				query.append(_SQL_SELECT_PLUGINPORTLETPREFERENCES);

				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);

				sql = query.toString();
			}
			else {
				sql = _SQL_SELECT_PLUGINPORTLETPREFERENCES;

				if (pagination) {
					sql = sql.concat(PluginPortletPreferencesModelImpl.ORDER_BY_JPQL);
				}
			}

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				if (!pagination) {
					list = (List<PluginPortletPreferences>)QueryUtil.list(q,
							getDialect(), start, end, false);

					Collections.sort(list);

					list = new UnmodifiableList<PluginPortletPreferences>(list);
				}
				else {
					list = (List<PluginPortletPreferences>)QueryUtil.list(q,
							getDialect(), start, end);
				}

				cacheResult(list);

				FinderCacheUtil.putResult(finderPath, finderArgs, list);
			}
			catch (Exception e) {
				FinderCacheUtil.removeResult(finderPath, finderArgs);

				throw processException(e);
			}
			finally {
				closeSession(session);
			}
		}

		return list;
	}

	/**
	 * Removes all the plugin portlet preferenceses from the database.
	 *
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public void removeAll() throws SystemException {
		for (PluginPortletPreferences pluginPortletPreferences : findAll()) {
			remove(pluginPortletPreferences);
		}
	}

	/**
	 * Returns the number of plugin portlet preferenceses.
	 *
	 * @return the number of plugin portlet preferenceses
	 * @throws SystemException if a system exception occurred
	 */
	@Override
	public int countAll() throws SystemException {
		Long count = (Long)FinderCacheUtil.getResult(FINDER_PATH_COUNT_ALL,
				FINDER_ARGS_EMPTY, this);

		if (count == null) {
			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(_SQL_COUNT_PLUGINPORTLETPREFERENCES);

				count = (Long)q.uniqueResult();

				FinderCacheUtil.putResult(FINDER_PATH_COUNT_ALL,
					FINDER_ARGS_EMPTY, count);
			}
			catch (Exception e) {
				FinderCacheUtil.removeResult(FINDER_PATH_COUNT_ALL,
					FINDER_ARGS_EMPTY);

				throw processException(e);
			}
			finally {
				closeSession(session);
			}
		}

		return count.intValue();
	}

	/**
	 * Initializes the plugin portlet preferences persistence.
	 */
	public void afterPropertiesSet() {
		String[] listenerClassNames = StringUtil.split(GetterUtil.getString(
					com.liferay.util.service.ServiceProps.get(
						"value.object.listener.it.tref.liferay.mapit.map.model.PluginPortletPreferences")));

		if (listenerClassNames.length > 0) {
			try {
				List<ModelListener<PluginPortletPreferences>> listenersList = new ArrayList<ModelListener<PluginPortletPreferences>>();

				for (String listenerClassName : listenerClassNames) {
					listenersList.add((ModelListener<PluginPortletPreferences>)InstanceFactory.newInstance(
							getClassLoader(), listenerClassName));
				}

				listeners = listenersList.toArray(new ModelListener[listenersList.size()]);
			}
			catch (Exception e) {
				_log.error(e);
			}
		}
	}

	public void destroy() {
		EntityCacheUtil.removeCache(PluginPortletPreferencesImpl.class.getName());
		FinderCacheUtil.removeCache(FINDER_CLASS_NAME_ENTITY);
		FinderCacheUtil.removeCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
		FinderCacheUtil.removeCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
	}

	private static final String _SQL_SELECT_PLUGINPORTLETPREFERENCES = "SELECT pluginPortletPreferences FROM PluginPortletPreferences pluginPortletPreferences";
	private static final String _SQL_SELECT_PLUGINPORTLETPREFERENCES_WHERE = "SELECT pluginPortletPreferences FROM PluginPortletPreferences pluginPortletPreferences WHERE ";
	private static final String _SQL_COUNT_PLUGINPORTLETPREFERENCES = "SELECT COUNT(pluginPortletPreferences) FROM PluginPortletPreferences pluginPortletPreferences";
	private static final String _SQL_COUNT_PLUGINPORTLETPREFERENCES_WHERE = "SELECT COUNT(pluginPortletPreferences) FROM PluginPortletPreferences pluginPortletPreferences WHERE ";
	private static final String _ORDER_BY_ENTITY_ALIAS = "pluginPortletPreferences.";
	private static final String _NO_SUCH_ENTITY_WITH_PRIMARY_KEY = "No PluginPortletPreferences exists with the primary key ";
	private static final String _NO_SUCH_ENTITY_WITH_KEY = "No PluginPortletPreferences exists with the key {";
	private static final boolean _HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE = GetterUtil.getBoolean(PropsUtil.get(
				PropsKeys.HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE));
	private static Log _log = LogFactoryUtil.getLog(PluginPortletPreferencesPersistenceImpl.class);
	private static PluginPortletPreferences _nullPluginPortletPreferences = new PluginPortletPreferencesImpl() {
			@Override
			public Object clone() {
				return this;
			}

			@Override
			public CacheModel<PluginPortletPreferences> toCacheModel() {
				return _nullPluginPortletPreferencesCacheModel;
			}
		};

	private static CacheModel<PluginPortletPreferences> _nullPluginPortletPreferencesCacheModel =
		new CacheModel<PluginPortletPreferences>() {
			@Override
			public PluginPortletPreferences toEntityModel() {
				return _nullPluginPortletPreferences;
			}
		};
}